# 首选项配置

> 中括号内表示可选配置，配置时不要把中括号也写进去 

## 1. Connor_AVIC_[版本类型]

配置创建工艺界面，对齐使用空格对齐（shift+space切换中英空格）

```text
格式：“[*][#]标题名称=写入属性配置[=提取属性配置[+GY][=下拉内容1;下拉内容2;下拉内容3]]”
*：必填
#：不可编辑
属性配置格式：属性位置.属性名称（属性位置包含 item, rev, itemmaster, revmaster）
--------------------------------------------
特殊写入属性配置：
object_type：必配，指定新建对象的类型，如有下拉值，配置“真实类型名称[-新对象版本(父)与用户选择版本(子)的关联关系名称[-用户选择版本(父)与新对象(子)的关联关系名称]]”
```

## 1.1 Connor_AVIC_ProcType_Symbol

配置创建工艺功能中，工艺类型和类型简写的对应关系，选择类型后将创建工艺界面首选项中的配置的“[PROC_TYPE]”替换为对应简写

示例

```text
MEProcess=JJ
Item=ZP

创建工艺界面中的配置示例：
工艺编码=item.object_desc=[PROC_TYPE]+item.item_id
```

## 2. Connor_AVIC_MEOP_[工艺版本类型]

配置工艺版本类型对应的创建工序界面中，工序类型的列表

```text
格式：“工序类型真实名称[=工艺短描述的内容]”
```

## 3. Connor_AVIC_MEOP_Properties

配置创建工序界面显示的属性

> 注意工艺短描述属性配置在jar包中的文件：`cn/net/connor/process/newmeop/newmeop.properties`，shortdesc.PROPNAME=[格式同下方首选项说明]
>
> 如果配置了版本表单属性ac5_Type，新对象版本号取填写的值+00

```text
格式：“[*][#][$]显示名称=属性位置.属性名称[=附加lov的名称[=从工艺提取属性的属性位置.属性名称[=属性是否显示配置]]]”（属性位置包含 item, rev, itemmaster, revmaster）
注意：此处增加[$]符号的配置，表示控件是文本域，可多行输入。[*][#]同上，分别表示必填和只读

属性是否显示配置格式：“属性位置.属性名称:配置文本”。当属性真实值等于配置文本时，这条配置为有效配置，控件可见；否则忽略该行配置。
示例：“版本描述=rev.object_desc=BillCodes==rev.object_desc:1”

20210112: 附加lov名称配置可以替换为用英文分号分隔的下拉值列表
```

## 3.5 Connor_AVIC_MEOP_LOV_[属性名称]

配置创建工序界面中，如果属性A存在LOV且配置了首选项“Connor_AVIC_MEOP_LOV_属性A”，当属性A选择值之后，将配置的指定值填写到其他属性

```text
格式：“选择的真实值:属性名称1=指定的值1;属性名称2=指定的值2;属性名称3=指定的值3”
```

## 4. Connor_AVIC_MEOPEXCEL_[属性真实名称]

配置创建工序和工艺编辑视图界面中对应[属性真实名称]的选择按钮逻辑

```text
第一行：配置excel数据集的uid，可按照创建界面选择的类型区分。首先查找类型对应uid，未找到时查找默认uid。
格式：“默认uid;真实类型名称1:类型1使用的uid;真实类型名称2:类型2使用的uid;...”
第二行开始：配置表格显示和属性映射信息
格式：“[#]界面列名=excel列名[=属性位置.属性名称[=默认列宽]]”
#：表示添加该列的查询
```

## 5. Connor_AVIC_ME_Properties_[对象真实类型]

配置工艺视图中选择对应[对象真实类型]时，要在界面中显示的属性

```text
配置方法同首选项：Connor_AVIC_MEOP_Properties

20201117 增加额外配置：某个下拉框(控制属性)选择指定的值时，隐藏指定的控件(隐藏属性)
格式：“HIDE_LISTENER:控制属性位置.控制属性名称=指定值:隐藏属性位置1.隐藏属性名称1;隐藏属性位置2.隐藏属性名称2”
示例：“HIDE_LISTENER:rev.object_desc=Civi:item.object_desc;item.object_name”
```

## 6. Connor_GZBomExport

配置导出工装BOM明细表导出信息

```text
多值，格式：[#]属性名称
配置‘#’表示属性名称在bomline上，否则从版本表单获取
可选配内容：
1. 写入起始行：在其中一行配置数字，仅支持0-9
2. 默认文件名后的日期后缀：##+日期格式。(##_yyyy_MM_dd)
```

示例

```text
object_name
object_desc
#bl_quantity
#bl_item_item_id
```

## 7. Connor_Signature_[版本类型]

配置Word Excel签名

```text
多值，格式：word域名或excel文本框名称=版本表单属性名称或固定内容[=分隔符=取分隔后的第几个内容(从零开始)]
```

示例

```text
名称1=ac5_Assist1=;=0
名称2=ac5_Assist1=;=1
名称3=ac5_Assist1=;=2
日期=ac5_riqi
文本1=写入首选项配置的内容
```

## 8. 工序编制特殊文本树 

> 首选项，单值，配置文件夹uid，文件夹内放置保存特殊文本的excel表格，加载后按sheet页的名称分标签显示
> 
> Connor_AVIC_GXBZ_Common_Folder: 配置通用文件夹或Excel的uid
> 
> Connor_AVIC_GXBZ_Personal_Folder：配置个人文件夹或Excel的uid

Excel 格式说明

> 从左上角开始写入内容，单元格排列保持树形即可，注意不要在内容之间插入空列

真实值说明：真实值有多种配置方式

> 1. 在真实值单元格内容前加“#RV#”
> 
> 2. 在配置的uid后添加“#RealValue#列号”，配置后，对应文件夹内所有excel或指定uid的excel的对应列作为真实值列


## 9. 工序编制表格

> 首选项，多值，格式见下方说明
> 
> Connor_AVIC_GXBZ_Bomline: 配置界面上方的表格
> 
> Connor_AVIC_GXBZ_[对象类型]: 配置界面下方的表格，对象类型是选择bom行对应item的真实类型名称

首选项格式说明：

> 第一行配置：指定的对象类型
> 
> 指定对象类型后，该表格只加载指定类型的子行，如存在新建功能，则使用该类型新建对象
> 
> 如不需要指定类型，首行需配置"bomline"，此表格仅支持读取和修改bom行属性

> 第二行开始配置属性映射
> 
> 格式：[列宽][$每行最大字符数量][属性位置.]属性真实名称[=属性值(按该值进行过滤)]
> 
> 列宽：选配，直接在前面加数字
>
> 每行最大字符数量：手动输入时，如果某行超过此数量则自动添加换行符
> 
> 属性位置：如不写即默认bomline属性（位置包含：bomline, item, rev, itemmaster, revmaster）
> 
> 属性真实名称：定义的属性名称，如要支持换行，请务必配置“bl_sequence_no”属性
> 
> 属性值：配置后，只显示属性匹配的行（如配置指定的事例类型）
>
> revmaster.ac5_WorkstepNumber 属性进行特殊处理

20210119更新: 下方表格支持GDT编辑器,属性名称配置到GDT_properties首选项即可

示例

```text
bomline
bl_indented_title
bl_occ_type=MEAssemble
200bl_item_object_name
```

```text
Item
bomline.bl_sequence_no
bomline.bl_indented_title
150item.object_name
```

## 10. 工序编制表单属性

> 首选项：Connor_AVIC_GXBZ_[对象类型]
> 
> 多值，格式：[\*]属性真实名称[=下拉值1;下拉值2;下拉值3]
>
> \*：表示属性在版本上，不添加\*表示属性在版本表单
>
> 下拉值：配置后，若属性上未定义下拉值，则变更属性控件为下拉框，下拉内容为分号分隔后的配置内容；若定义下拉值，以bmide中定义的lov为准。

示例

```text
object_name
*object_name=名称1;名称2;名称3
object_type
creation_date
```

## 11. 工序编制 TC兼容性

> 由于工序编制界面基于javafx开发，TC的文本检测未进行兼容，所以在文本框中进行复制粘贴和剪切时存在问题。
> 
> 需要修改 com.teamcenter.rac.common.xxxx.jar 中的 plugin.xml

```xml
<definition id="com.teamcenter.rac.common.textActive">
    <with variable="activeContexts">
        <iterate operator="or" ifEmpty="false">
            <or>
                <equals value="com.teamcenter.rac.aifrcp.swingtext"/>
                <equals value="com.teamcenter.rac.aifrcp.swttext"/>
            </or>
        </iterate>
    </with>
</definition>
```

修改为

```xml
<definition id="com.teamcenter.rac.common.textActive">
	<or>
		<with variable="activeContexts">
			<iterate operator="or" ifEmpty="false">
				<or>
					<equals value="com.teamcenter.rac.aifrcp.swingtext"/>
					<equals value="com.teamcenter.rac.aifrcp.swttext"/>
				</or>
			</iterate>
		</with>
		<with variable="activePartId">
			<equals value="cn.net.connor.process.meopview.MEOPEditView"/>
		</with>
	</or>
</definition>
```

## 12. 配置工道对象类型

> 配置首选项：Connor_AVIC_GDItem_Types，多值，配置工道对象的类型

## 13. 工艺卡片导出首选项（废除）

> 配置首选项中的类型使用“[选中工序行所在工艺的制造目标的版本类型”，配置见下方[Word报表通用配置](#Word报表通用配置)

```text
零部件列表：Connor_AVIC_GYKPSC_LBJLB_[类型]
工艺卡片：Connor_AVIC_GYKPSC_GYKP_[类型]
关键工序：Connor_AVIC_GYKPSC_GJGX_[类型]
工艺附图：Connor_AVIC_GYKPSC_GYFT_[类型]
工道附图：Connor_AVIC_GYKPSC_GDFT_[类型]
```

## 13.1 工艺卡片导出首选项（改）

> 配置目录首选项：Connor_AVIC_GYKPSC_CATE_[选择的工序版本类型名称]
>
> 配置导出工艺卡片的结构，多值，配置首选项名称的前缀，导出时使用“前缀+制造目标的版本类型名称”找到配置首选项
> 
> 第一行配置零部件列表首选项名称的的前缀，
> 
> 第二行开始配置其他页首选项名称的前缀，开头加“GD#”表示该行是工道下导出数据集的配置；开头加“KEY#”表示该行是关键工序页的配置，如果是关键工序，则导出此页。

示例

```text
Connor_AVIC_GYKPSC_LBJLB_
Connor_AVIC_GYKPSC_GYKP_
KEY#Connor_AVIC_GYKPSC_GJGX_
Connor_AVIC_GYKPSC_GYFT_
GD#Connor_AVIC_GYKPSC_GDFT_
Connor_Other_Page1_
Connor_Other_Page2_
Connor_Other_Page3_
Connor_Other_Page4_
Connor_Other_Page5_
Connor_Other_Page6_
Connor_Other_Page7_
Connor_Other_Page8_
Connor_Other_Page9_
Connor_Other_Page10_
```

## 14. 工艺规程导出首选项（废除）

> 配置首选项中的类型使用“[选中工艺的制造目标的版本类型”，配置见下方[Word报表通用配置](#Word报表通用配置)

```text
工艺规程：Connor_AVIC_GYKPSC_GYGC_[类型]
工艺签署：Connor_AVIC_GYKPSC_GYQSKP_[类型]
辅料清单：Connor_AVIC_GYKPSC_FLQD_[类型]
工艺程序：Connor_AVIC_GYKPSC_GYCXKP_[类型]
```

## 14.1 工艺规程导出首选项（改）

> 配置目录首选项：Connor_AVIC_GYGCSC_CATE_[选择的工艺版本类型名称]
>
> 配置导出工艺规程的结构，多值，配置首选项名称的前缀，导出时使用“前缀+制造目标的版本类型名称”找到配置首选项
> 
> 第一行配置分类辅料页首选项名称的前缀
> 
> 第二行配置工艺签署页首选项名称的前缀
> 
> 第三行开始配置其他页首选项名称的前缀

示例

```text
Connor_AVIC_GYKPSC_FLQD_
Connor_AVIC_GYKPSC_GYQSKP_
Connor_AVIC_GYKPSC_GYGC_
Connor_AVIC_GYKPSC_GYCXKP_
Connor_Other_Page11_
Connor_Other_Page12_
Connor_Other_Page13_
Connor_Other_Page14_
Connor_Other_Page15_
Connor_Other_Page16_
Connor_Other_Page17_
Connor_Other_Page18_
Connor_Other_Page19_
Connor_Other_Page20_
```

## Word报表通用配置

> 该首选项可以引用其他以"Connor_"开头首选项，直接在第一行配置其他首选项的名称，就不需要配置其他内容了

```text
首行配置模板word数据集的uid，工艺卡片界面中显示的名称从该数据集的名称获取
从第二行开始配置其他内容：格式“标识=配置内容”

标识说明
1. 特殊标识：
  STARTROW：配置表格数据开始行号，从1开始计数
  ENDROW: 配置表格数据结束行号，从1开始计数
  TABLEINDEX：配置填写模板中第几个表格，从1开始计数，默认1
  PICWIDTH：配置图片宽度，默认200
  PICHEIGHT：配置图片高度，默认200
  IMAGE: 配置图片（或excel）书签名称，配置后按附图模板处理，不输出子行数据
  CHECKIMAGE：
      配置图片为对应宽度和高度，则替换模板为另一个数据集，多个用英文分号分隔，取第一个匹配的数据集插入，格式“CHECKIMAGE=宽度|高度|模板数据集uid|插入word宽度|插入word高度”
      配置图片，如果数据集名称包含指定文本，则替换模板为另一个数据集，多个用英文分号分隔，取第一个匹配的数据集插入，格式“CHECKIMAGE=数据集名称中包含的值|模板数据集uid|插入word宽度|插入word高度”
      配置excel工作表名称对应模板，多个用英文分号分隔，格式“工作表名称包含文本|模板数据集uid”
  LINEGAP：制定表格行数据之间的空行数量，默认0
2. 文本域标识：配置文本域的名称
3. 表格的标识：配置列号，从1开始计数

配置内容说明
1. 格式：属性位置.属性名称[.默认值或NAME]
2. 如果需要拼接使用“+”连接，可连接固定文本（注意固定文本应避免出现属性定义的格式）
3. 属性位置包含：
  bomline, item, rev, itemmaster, revmaster：分别对应bom行，对象，版本，对象表单，版本表单（如果是表格的行数据，主体对象是非工道子行；否则主体是当前行）
  pbomline, pitem, prev, pitemmaster, prevmaster：分别对应bom行，对象，版本，对象表单，版本表单（主体对象是当前行的父行）
  mitem, mrev, mitemmaster, mrevmaster：分别对应制造目标的对象，版本，对象表单，版本表单（主体对象是制造目标）
  bomline2, item2, rev2, itemmaster2, revmaster2：分别对应bom行，对象，版本，对象表单，版本表单（仅用于表格中的行数据，主体对象是工道子行）
4. 配置“linenum”，对表格行从1开始计数
5. 如果要取子行的子行中的数据，配置“#目标行对象的类型.目标行的bom行属性名称”
6. 配置默认值后，如果属性值为空，则取配置的默认值，默认值对提取父行、祖父行、子行属性时不生效
7. 配置“属性位置.属性名称.NAME”时，读取属性显示名称

页码和页数：自动填写，表示合并前的页码和页数，在word中设置域名“页码”和“页数”即可

汇总页数：自动填写，表示合并后的页数，在word中设置域名“总页数”或“总页数减一”

汇总页码：自动填写，表示合并后的页码，在word中设置域名“总页码”或“总页码减一”

汇总实际页数：自动填写，表示合并后的word中的实际物理页数，在word中设置域名“总实际页数”或“总实际页数减一”

图片：在需要插入图片的word模板中设置书签“图片”

注：为了105项目配置方便，将【页码，总页码】【页数，总页数】功能进行对调
```

示例

```text
wWX9SQz_5YkutB
startrow=6
endrow=10
image=图片
checkimage=100|100|xxxxxxxuid
y4=bomline.object_string
y5=item.object_string
y6=制造目标=+mrev.object_string
y7=revmaster.object_string
1=linenum
2=item.item_id
3=item.object_name
6=工道属性示例：+bomline2.bl_indented_title
7=主要设备示例：+Ac5_MainDevice.bl_item_object_name
```

【备用配置，目前不需要，请忽略】LINEDATA标识的特别说明：
格式：“属性位置.关系名称1|关系名称1下查找的子对象类型1.关系名称2|关系名称2下查找的子对象类型2.关系名称3|关系名称3下查找的子对象类型3
如果子对象类型存在多个，用英文分号分隔；如果取所有类型，子对象类型填“*”。
bom装配关系，和bom行类型都用“bomline”标识。

## Word报表通用配置更改

20200814: 

```text
1. 增加特殊标识：
  FILTERTYPE：按类型过滤子行，配置需要导出子行对象的类型名称，多个用英文逗号分隔，示例：“FILTERTYPE=MEOP;Item”
  READGRANDCHILD：是否需要读取子行的子行中的数据。配置“READGRANDCHILD=true”后，数据会被加载，其属性位置用cbomline, citem, crev, citemmaster, crevmaster标识
  GRANDCHILDTYPE：按类型过滤子行的子行，配置子行的子行对象的类型名称，多个用英文逗号分隔，示例：“GRANDCHILDTYPE=MEOP;Item”
  WRAPLINE：配置自动换行，格式“WRAPLINE=列号1=最大长度1;列号2=最大长度2”，示例：“WRAPLINE=4=15;9=10”
2. 关于“加载子行的子行”的特别说明
    特殊配置：如果需要读取cbomline父行或祖父行的某个bom行属性，配置“parent.父行属性名称”或“grandparent.祖父行属性名称”。
    数据加载后，在表格中，可提取的对象按表格行排列如下
  excel行1：子行1，子行1的子行1
  excel行2：子行1的子行2 （这一行的数据中已经没有子行，无法再通过bomline, item, rev等获取子行数据，可以配置“parent.父行属性名称”获取数据
  excel行3：子行1的子行3
  excel行4：如果配置隔行，这里没有数据可以取
  excel行5：子行2，子行2的子行1
  excel行6：子行2的子行2
  excel行7：子行2的子行3
3. 提取bomline下数据集的页数：“列号=pagecount.数据集名称的前缀”。示例：“5=pagecount.工艺卡片_”
4. 如果要取子行的子行中的数据，配置“#目标行对象的类型.目标行的bom行属性名称”，示例：“#设备对象类型.bl_item_object_name”
5. 按子行类型重排的功能已弃用，不要配置属性位置（ bomline2, item2, rev2, itemmaster2, revmaster2）
    类型过滤请通过FILTERTYPE配置
6. 插入页保持原格式：在模板文件的开始和末尾插入“页面布局-分隔符-连续”
```

20200819

```text
1. 增加特殊标识：
  MOVETOTOP：配置列数据向上移动至非空行，格式“MOVETOTOP=列号1;列号2”，示例：“MOVETOTOP=5;6;7;8;9”
  详细说明：对单独一列的数据进行重排，假设配置了列A，如果某行A列数据不为空，且此行上方的行A列数据为空，则移除此行中A列的数据，填写到上方A列为空的行中。
  查找空行范围为从上一行开始，向上找到空数据行为止（目前空数据行只有配置的隔行）
  注意配置的列中不要配置自动换行WRAPLINE
```

20200922

```text
1. 增加特殊标识
 SPLITLINE：配置按字符分隔行，格式“SPLITLINE=列号1=分隔字符1$;列号2=分隔字符2”，多个配置之间用“$;”分隔，示例：“WRAPLINE=4=;$;9=10”
 REWRITELINENUM：配置重写行号，格式“REWRITELINENUM=标识列;行号列”，标识列的数据以“#LN”开头时，在行号列填写新的行号
 READGRANDCHILDASTARGET：将通过READGRANDCHILD和GRANDCHILDTYPE配置得到的子行的子行作为表格中每行的主体，相同的对象不重复添加，作为主体后，属性位置不需要配置c开头
 增加属性位置“sp”：配置READGRANDCHILDASTARGET后，用于读取与子行的子行所关联的父行的版本表单属性
```

20201029

```text
1. 增加特殊标识
  格式：ADDPAGECOUNTFROMMEOP=数据集名称前缀
  功能：导出当前模板时，从子行中105工序类型版本的规范关系下，找到以配置的“数据集名称前缀”为前缀的最新word数据集，将其页数加到总页数
```

20201030

```text
1. 在行数据的第一行增加顶层信息，在原来的属性位置前加“T”，如“TBOMLINE.bl_item_object_name”
2. 可以通过“pline.父行属性名称”读取属性位置bomline的父行的属性
```

20201203

```text
1. 提取属性配置支持表格属性：格式“属性位置.表格属性名称-表格行属性名称[-连接符]”。连接符默认为“#ROW#”，用于连接多行的值
2. 提取子行某个类型的属性：格式“#子行对象类型1|子行对象类型2|子行对象类型3#属性位置.属性名称”，示例：“#设备对象类型#revmaster.object_name”
```

20201228

```text
1. 新增首选项：Connor_AVIC_WORD_Protect，单值，配置word导出功能生成的word密码。
```

20210112

```text
1. 所有模板中的文本域可以使用书签替换
```

20210413

```text
工序附表首选项：Connor_AVIC_GYKPSC_CATE_A3_工序版本类型名称，Connor_AVIC_GYKPSC_CATE_A4_工序版本类型名称

新增配置：APPENDFILE=数据集名称[;表格页码行号;表格页码列号;表格页数行号;表格页数列号]
功能：导出当前模板时，从导出行版本的规范关系下，找到包含配置文本的word数据集，将其附加到导出文件末尾，并填充页码和页数，页数取该文件的实际页数
页码页数替换规则：
1. 未配置表格位置时，按查找顺序替换word中的文本“第  页”“共  页”，中间为两个半角空格
2. 配置表格位置时，按表格顺序替换word中每个表格对应位置的文本

更改配置：工序附表和工艺卡片使用相同代码运行，工序附表功能将目录首选项第一行更改为导出数据集名称配置
数据集名称格式：用+拼接选择的对象版本的“属性位置.属性名称”或其他固定文本，末尾可用“:”连接导出文件日期后缀，如“ITEM.item_id+工序附表A3:_yyyy_MM_dd”

附加图片时从3D快照提取Image文件
```

20210527

```text
1. CHECKIMAGE：
      配置图片为对应宽度和高度，则替换模板为另一个数据集，多个用英文分号分隔，取第一个匹配的数据集插入，格式“CHECKIMAGE=宽度|高度|模板数据集uid|插入word宽度|插入word高度”
      配置图片，如果数据集名称包含指定文本，则替换模板为另一个数据集，多个用英文分号分隔，取第一个匹配的数据集插入，格式“CHECKIMAGE=数据集名称中包含的值|模板数据集uid|插入word宽度|插入word高度”
      配置excel工作表名称对应模板，多个用英文分号分隔，格式“工作表名称包含文本|模板数据集uid”
      
2. 提取关系下某类型对象的属性
格式：属性位置.关系属性名称.关系下的子对象类型.子对象属性名称[-连接符]
取所有类型：关系下的子对象类型配置“*”
连接符默认为英文分号
示例：rev.IMAN_specification.*.object_name-;

3. 替换属性值
在属性提取配置后添加“:”，冒号后是替换配置，多个替换用英文分号分隔
格式：属性位置.属性名称:被替换值1=替换值1;被替换值2=替换值2
示例：rev.object_desc:每个=个
```

20210602

```text
1. 在图片页写入图片数据集名称：配置域或书签名称为“图片的书签名_Name”

```

20210604

```text
1. 换行分隔符更改，原“\n”建议改为“\r\n|\r|\n”
2. 计算bom行出现的数量，属性格式：“quantity.随便写”，在属性位置的地方写“quantity”，属性名称的位置不使用，仅作为格式的占位，示例：“3=quantity.xxx”
```

20210608

```text
1. MOVETOTOP配置增加格式“MOVETOTOP=移动到顶部的列1=[跟随列1移动的列a,跟随列1移动的列2];移动到顶部的列2”
示例：MOVETOTOP=4=5;2
示例说明：将第四列和第二列按原逻辑移动到顶部，但是在移动第四列的时候，第五列的数据跟随第四列一起移动
```

20211206

```text
1. 替换属性值扩展
扩展配置：在属性提取配置后添加“:”，冒号后格式“EXCEL-excel数据集uid-列号1-列号2”，列号从零开始，功能是将列1的值替换为列2的值
格式：属性位置.属性名称:EXCEL-excel数据集uid-列号1-列号2
示例：rev.object_desc:EXCEL-xxxxxxx-0-2
```

## 15 截图

> 配置首选项：Connor_ScreenShot_Command，单值，配置截图工具路径

示例：

```text
D:\Siemens\Teamcenter12\portal\plugins\SogouSnapShot.exe
```

## 16 材料试件编辑

> 首选项名称为 “Connor_AVIC_CLSJBJ_版本类型名称”

```text
格式：“[*][#]标题名称=写入属性配置[=提取属性配置[=下拉内容1;下拉内容2;下拉内容3]]”
*：必填
#：不可编辑
属性配置格式：属性位置.属性名称（属性位置包含 item, rev, itemmaster, revmaster）
对齐：在标题名称中加入适量空格进行对齐
标题换行：<html>第一行<br/>第二行</html>

特殊配置：
#TITLE=窗口标题
#SIZE=窗口宽度,窗口高度
#COLUME=属性列数量
#INFO=修改完成的提示内容
#DONT_CLOSE_DIALOG (添加此行则在修改完成后不关闭窗口)
```

示例

```text
#物料编码: =item.item_id
物料名称: =item.object_name
Assist1=revmaster.ac5_Assist1
<html>Assist2<br/>第二行</html>=revmaster.ac5_Assist2
*keypro=revmaster.ac5_KeyProOrNot
数量=bomline.bl_quantity
#TITLE=材料定额
#SIZE=800,300
#COLUME=3
#INFO=修改成功了
#DONT_CLOSE_DIALOG
```

## 16.1 材料试件编辑特殊配置

> 首选项名称为 “Connor_AVIC_CLSJBJ_版本类型名称_plus”

```text
1. 设置仅能输入数字，格式：“NUMBER=标题名称1;标题名称2;标题名称3”
2. 设置多个属性输入时，在其中一个属性填写值后，禁用其他非空属性控件，格式：“SELECT=标题名称1;标题名称2;标题名称3”
3. 设置通过一个控件的值控制其他控件是否可编辑，格式：“SWITCH=控制者标题名称=值1:被控制者标题名称1;!被控制者标题名称2|值2:被控制者标题名称”
用“|”分隔不同值的配置，用“;”分割对应值控制的控件标题名称
被控制者标题名称前加“!”表示设置为不可编辑
当控制者对应控件的值发生变化时，先将该行首选项所有涉及的被控制者设置为可编辑，再根据变化后的值，设置被控制者是否可编辑
支持所有类型控件（文本框，下拉框），注意标题名称是否有符号
```

示例：

```text
NUMBER=Assist1
NUMBER=Assist2
SELECT=Assist1;Assist2;数量;keypro
```

## 17 在AD中打开文件

> 配置首选项：Connor_AVIC_OpenInAD，多值

```text
第一行：配置目标文件夹路径
第二行开始配置其他内容

1. 数据集路径。格式：“对象1和选择工程版本的关系:对象1的类型:数据集和对象1版本的关系:数据集的后缀:工程版本表单中记录对象1版本号的属性名称”
2. 子文件夹名称。格式：“FOLDER=数据集和选择工程版本的关系:数据集的后缀”，子文件夹的名称取数据集的名称
3. 打开文件。格式：“OPEN=打开的文件后缀1:打开的文件后缀2”
4. 注意以上的分隔符都是英文冒号
```

示例

```text
C:\PCB_PROJECT
FOLDER=IMAN_specification:.PrjPCB
OPEN=PrjPCB:txt:docx
Ac5_EDADL_ref:原理图Item类型:IMAN_specification:数据集后缀:ac5_YLTRev
Ac5_Drawings_Irela:PCB对象类型:IMAN_specification:数据集后缀:ac5_PCBRev
```

配置右键菜单

> 打开jar包中的plugin.xml文件，将value="ItemRevision"中的ItemRevision修改为需要显示菜单的类型，多个类型可以用英文逗号分隔

```xml
<command commandId="cn.net.connor.process.commands.OpenPCBCommand2" id="popups.openpcbds">
 	<visibleWhen>        
        <and>
            <iterate ifEmpty="false">
                <adapt type="com.teamcenter.rac.kernel.TCComponent">
               		<or>
       					<test
                            property="com.teamcenter.rac.kernel.TCComponent.typeClass"
                            value="ItemRevision">
                        </test>
       				</or>
                </adapt>
            </iterate>
        </and>               
     </visibleWhen>
 </command>
```

## 18. 工艺分工

1. 首选项：Connor_AVIC_GYFGPZ_LXSX，多值，格式："[产品/组部件/零件:]对象类型真实名称"
2. 首选项：Connor_AVIC_GYFGPZ_SXPZ，多值，格式："表头名称=属性位置.属性名称"，属性位置包含：item,rev,itemmaster,revmaster,bomline，工艺属性位置前加'M'
3. 首选项：Connor_AVIC_GYFGPZ_HANDLE，单值，配置handler名称“CONNOR-check-form-attribute”，handler名称配置在任务开始节点
4. 首选项：Connor_AVIC_GYFGPZ_WORKFLOW，单值，配置正式分工的工作流程模板名称

## 19. 工序号表格

1. 首选项：Connor_AVIC_SQGXH_GXLX，多值，配置工序对象类型真实名称
2. 首选项：Connor_AVIC_SQGXH_SXBJ，多值，格式："表头名称=属性位置.属性名称"，属性位置包含：item,rev,itemmaster,revmaster,bomline

## 20. 流程名称提取

首选项 Connor_CopyWorkflowName，多值，格式："选择的对象类型名称=提取属性拼接配置"

提取属性拼接配置：

```text
单属性配置：直接配置所选类型的属性名称
引用或关系属性：配置"关系属性名称.引用对象属性名称"，引用可以嵌套，如从版本获取对象所有者的id"items_tag.owning_user.user_id"
固定内容：直接配置内容（不能配置加号）
以上配置可以用加号连接"items_tag.item_id+/+item_revision_id"
```

特殊配置：

```text
提取uid：配置属性名称为"uid"，提取关系下对象的uid示例"items_tag.uid"
属性显示值：属性名称前加一个"#"，如果是引用属性，则在最后一个属性名称前加"#"
```

示例：

```text
Folder=object_name+_[+contents+]
ItemRevision=items_tag.item_id+/+item_revision_id+:+IMAN_master_form_rev.object_string
```

## 21. 通过产品查询特殊过程

首选项 CONNOR_AVIC_TSGC_Export，多值

格式：

```text
第一行配置导出文件名称，可以包含日期格式（当配置日期格式时，文件名不能包含后缀或其他字母）
第二行开始配置属性映射，格式“表头名称=属性位置.属性名称”
属性位置包含：
item, rev, itemmaster, revmaster 对应特殊过程的对象、版本、对象表单、版本表单
gitem, grev, gitemmaster, grevmaster 对应工艺的对象、版本、对象表单、版本表单
pitem, prev, pitemmaster, prevmaster 对应工序的对象、版本、对象表单、版本表单
mitem, mrev, mitemmaster, mrevmaster 对应制造目标的对象、版本、对象表单、版本表单

特殊映射：“表头名称=index”，填写序号
```

## 22. 特殊过程被引用情况

首选项 CONNOR_AVIC_TSGC_Ref_Export，多值

格式：

```text
同 CONNOR_AVIC_TSGC_Export
```

## 23. 生成过程记录卡

首选项1 CONNOR_AVIC_GCJLK_Query，多值，配置数据库连接和查询语句

格式：

```text
第一行配置数据库连接
第二行配置数据库登录用户
第三行配置数据库登录密码
第四行及之后的所有行为查询语句（即可以拆分成多行配置）
```

查询语句要求：

```text
查询结果仅需要三列，分别对应界面中的订单编号、数量、是否首件鉴定
查询条件为1个，对应对象ID，填写对应值的地方用“?”代替
```

示例：

```text
jdbc:oracle:thin:@127.0.0.1:1521:TC12
infodba
infodba
select
a.DocNo as MODocNo,
a.ProductQty,
(case a.DescFlexField_PrivateDescSeg23
when 10 then '是'
when 20 then '否'
end) as isFirstIdentify2
from MO_MO a
inner join CBO_ItemMaster b on a.ItemMaster=b.ID
where b.Code=? and a.DocState='2' and a.Cancel_Canceled=0 and a.IsHoldRelease=0
```

首选项2 CONNOR_AVIC_GCJLK_Export，多值

格式：

```text
配置方式和工艺卡片导出方式相同，非列属性部分有工艺行和制造目标，列属性部分为工序
需要的特殊配置：
订单编号、数量、是否首件鉴定，这三个界面中查询到的值以书签的形式插入到模板中，书签的名称和界面中列名相同
导出时自动填写到书签的位置
```