package cn.net.connor.process.choose;

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextField;

import com.teamcenter.rac.aif.AbstractAIFDialog;
import com.teamcenter.rac.util.MessageBox;

import cn.net.connor.process.ProcessLocale;
import k.KDialog;
import k.KDialogController;
import k.util.KUtil;

@SuppressWarnings("serial")
public class ChooseDialog extends KDialog {

	private ChooseDialogController controller;
	private JButton b_ok;
	private JButton b_cel;
	private JButton b_search;

	public ChooseDialog(AbstractAIFDialog newMeopDialog, KDialogController controller) {
		super(newMeopDialog,true,controller);
		this.controller = (ChooseDialogController) controller;
	}

	@Override
	protected void addListeners() {
		this.b_cel.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				disposeDialog();
			}
		});
		this.b_ok.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				try {
					controller.doSelect();
				} catch (Exception e1) {
					e1.printStackTrace();
					MessageBox.post(ChooseDialog.this,e1);
				}
			}
		});
		this.b_search.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				try {
					controller.doSearch();
				} catch (Exception e1) {
					e1.printStackTrace();
					MessageBox.post(ChooseDialog.this,e1);
				}
			}
		});
	}

	@Override
	protected void initUI() {
		this.setTitle(ProcessLocale.getString("select.TITLE"));
		this.setPreferredSize(new Dimension(900, 500));
		this.setMinimumSize(new Dimension(550, 400));
		this.setLayout(new BorderLayout());
		this.add(BorderLayout.CENTER, initTablePanel());
		this.add(BorderLayout.EAST, initSearchPanel());
	}

	private Component initBtnPanel() {
		JPanel panel = new JPanel(new FlowLayout(FlowLayout.CENTER, 10, 0));
		panel.setBorder(BorderFactory.createEmptyBorder(0, 0, 10, 0));
		this.b_search = new JButton(ProcessLocale.getString("search"));
		this.b_ok = new JButton(ProcessLocale.getString("ok"));
		this.b_cel = new JButton(ProcessLocale.getString("cancel"));
		if (controller.searchCols.size() > 0) {
			panel.add(b_search);
		}
		panel.add(b_ok);
		panel.add(b_cel);
		return panel;
	}

	private Component initSearchPanel() {
		JPanel panel = new JPanel(new BorderLayout());
		if (controller.searchCols.size() == 0) {
			this.add(BorderLayout.SOUTH, initBtnPanel());
			return panel;
		}
		JPanel searchPanel = new JPanel(new GridBagLayout());
		searchPanel.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
		GridBagConstraints s = getGridBagConstraints(0, 0, new Insets(5, 5, 5, 5));
		for (String title : controller.searchCols) {
			KUtil.newRow(searchPanel, new JLabel(title), s, 1);
			JTextField textField = new JTextField(12);
			controller.searchComps.put(title, textField);
			KUtil.addCol(searchPanel, textField, s, 1, 1);
		}
		s.weighty = 1;
		KUtil.newRow(searchPanel, new JLabel(""), s, 1);
		JScrollPane scroll = new JScrollPane(searchPanel);
		scroll.setBorder(null);
		panel.add(BorderLayout.CENTER, scroll);
		panel.add(BorderLayout.SOUTH, initBtnPanel());
		return panel;
	}

	private Component initTablePanel() {
		JPanel panel = new JPanel(new BorderLayout());
		panel.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 0));
		JScrollPane scroll = new JScrollPane(controller.tableBean.getTable());
		panel.add(BorderLayout.CENTER, scroll);
		return panel;
	}

}
