package cn.net.connor.process.commands;

import org.eclipse.swt.widgets.Display;
import org.eclipse.ui.IViewPart;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.IWorkbenchWindow;

import com.teamcenter.rac.aif.AbstractAIFApplication;
import com.teamcenter.rac.aifrcp.AIFUtility;
import com.teamcenter.rac.util.PlatformHelper;

import k.KCommand;
import k.util.KUtil;

public class OpenViewCommand extends KCommand{

	public OpenViewCommand(AbstractAIFApplication app, String commandId, String actionInfo) {
		super(app, commandId, actionInfo);
	}

	@Override
	protected void executeCommand() throws Exception {
		System.out.println("Open View: "+actionInfo);
		if(KUtil.isEmpty(actionInfo)) {
			return;
		}
		Display.getDefault().asyncExec(new Runnable() {
			@Override
			public void run() {
				try {
					IWorkbenchWindow var1 = AIFUtility.getActiveDesktop().getDesktopWindow();
					IWorkbenchPage var2 = var1.getActivePage();
					IViewPart sv = var2.findView(actionInfo);
					if (sv == null) {
						sv = var2.showView(actionInfo);
					}
					PlatformHelper.getCurrentPage().activate(sv);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}
}
