package cn.net.connor.process.gcjlk;

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableColumnModel;

import com.teamcenter.rac.util.MessageBox;
import com.teamcenter.rac.util.Registry;

import k.KDialog;
import k.KDialogController;
import k.util.KUtil;

@SuppressWarnings("serial")
public class GCJLKDialog extends KDialog{

	private static final Registry REG= Registry.getRegistry(GCJLKDialog.class);
	private GCJLKDialogController controller;
	private JButton b_export;
	private JButton b_cancel;
	protected DefaultTableModel tableModel;
	protected JTable table;
	protected String[] header = new String[] {
			REG.getString("index.COL"),
			REG.getString("orderno.COL"),
			REG.getString("quantity.COL"),
			REG.getString("isfirst.COL")
	};
	private int [] headerWidth = new int[] {50, 180, 100, 120};
	protected JTextField tf_ItemID;
	protected JTextField tf_RevID;
	private JButton b_query;
	
	public GCJLKDialog(KDialogController controller) {
		super(controller);
		this.controller = (GCJLKDialogController)controller;
	}

	@Override
	protected void addListeners() {
		b_cancel.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				disposeDialog();
			}
		});
		b_query.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				try {
					controller.doQuery();
				} catch (Exception e1) {
					e1.printStackTrace();
					MessageBox.post(GCJLKDialog.this, e1);
				}
			}
		});
		b_export.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent e) {
				try {
					controller.doExport();
				} catch (Exception e1) {
					e1.printStackTrace();
					MessageBox.post(GCJLKDialog.this, e1);
				}
			}
		});
	}

	@Override
	protected void initUI() {
		this.setLayout(new BorderLayout());
		this.add(BorderLayout.NORTH, initQueryPanel());
		this.add(BorderLayout.CENTER, initTablePanel());
		this.add(BorderLayout.SOUTH, initBtnPanel());
	}

	private Component initBtnPanel() {
		JPanel panel = new JPanel(new FlowLayout(FlowLayout.CENTER, 25, 5));
		panel.add(this.b_export = new JButton(REG.getString("export.BTN")));
		panel.add(this.b_cancel = new JButton(REG.getString("cancel.BTN")));
		this.b_cancel.setPreferredSize(this.b_export.getPreferredSize());
		return panel;
	}

	private Component initTablePanel() {
		JPanel panel = new JPanel(new BorderLayout());
		panel.setBorder(BorderFactory.createEmptyBorder(0, 5, 0, 5));
		this.tableModel = new DefaultTableModel();
		this.table = new JTable(tableModel) {
			@Override
			public boolean isCellEditable(int row, int column) {
				return false;
			}
		};
		this.table.getTableHeader().setReorderingAllowed(false);
		this.table.setRowHeight(23);
		this.tableModel.setDataVector(null, header);
		TableColumnModel colModel = this.table.getColumnModel();
		for(int i=0; i<headerWidth.length; i++) {
			colModel.getColumn(i).setPreferredWidth(headerWidth[i]);
		}
		JScrollPane scroll = new JScrollPane(table);
		scroll.setPreferredSize(new Dimension(500, 300));
		panel.add(BorderLayout.CENTER, scroll);
		return panel;
	}

	private Component initQueryPanel() {
		JPanel panel = new JPanel(new GridBagLayout());
		GridBagConstraints s = getGridBagConstraints(0, 0, new Insets(5, 6, 5, 0));
		KUtil.newRow(panel, new JLabel(REG.getString("itemid.LABEL")), s, 1);
		KUtil.addCol(panel, this.tf_ItemID = new JTextField(18), s, 1, 0);
		KUtil.addCol(panel, new JLabel("   "+REG.getString("revid.LABEL")), s, 1, 0);
		KUtil.addCol(panel, this.tf_RevID = new JTextField(5), s, 1, 0);
		KUtil.addCol(panel, new JLabel("   "), s, 1, 1);
		s.insets.right = 5;
		KUtil.addCol(panel, this.b_query = new JButton(REG.getString("query.BTN")), s, 1, 0);
		this.tf_ItemID.setText(controller.targetItemID);
		this.tf_RevID.setText(controller.targetRevID);
		this.tf_ItemID.setEditable(false);
		this.tf_RevID.setEditable(false);
		return panel;
	}

}
