package cn.net.connor.process.hourcalculation;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;

import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.ss.usermodel.Workbook;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;

import com.teamcenter.rac.kernel.TCComponentDataset;
import com.teamcenter.rac.kernel.TCComponentTcFile;
import com.teamcenter.rac.kernel.TCException;
import com.teamcenter.rac.kernel.TCSession;

public class MethodUtil {
	/**
	 * ͨUIDݼ
	 * @param puid
	 * @param session
	 * @return
	 */
	public static File getDatByUid(String puid,TCSession session) {
		File fmsFile=null;
		TCComponentDataset dataset;
		try {
			dataset = (TCComponentDataset) session
					.stringToComponent(puid);
			if (dataset == null) {
				return null;
			}
			TCComponentTcFile[] file = dataset.getTcFiles();
			fmsFile = file[0].getFmsFile();
		} catch (TCException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		return fmsFile;
	}
	
	/**
	 * ͨļ·workbookfile.getAbsolutePath()
	 * @param filePath
	 * @return
	 */
	public static Workbook readExcel(String filePath) {
		Workbook wb = null;
		if (filePath == null) {
			return null;
		}
		String extString = filePath.substring(filePath.indexOf('.'));
		InputStream is = null;
		try {
			is = new FileInputStream(filePath);
			if (".xls".equals(extString)) {
				return wb = new HSSFWorkbook(is);
			} else if (".xlsx".equals(extString)) {
				return wb = new XSSFWorkbook(is);
			} else {
				return wb = null;
			}

		} catch (FileNotFoundException e) {
			System.out.println(e.toString());
		} catch (IOException e) {
			System.out.println(e.toString());
		} catch (NoClassDefFoundError e) {
			System.out.println(e.toString());
		}
		return wb;
	}
	
	
}
