package cn.net.connor.process.meopmodel;

import java.util.ArrayList;
import java.util.List;

import com.teamcenter.rac.aif.kernel.AIFComponentContext;
import com.teamcenter.rac.kernel.TCComponentBOPLine;
import com.teamcenter.rac.kernel.TCComponentItem;
import com.teamcenter.rac.kernel.TCComponentItemRevision;

import cn.net.connor.process.ProcessUtil;
import k.util.KUtil;

public class MeopModelBean {

	private TCComponentBOPLine meopLine;
	private List<TCComponentItemRevision> gxmxRevs;
	private String opNum;
	private String opName;
	
	private MeopModelBean(TCComponentBOPLine meopLine, List<TCComponentItemRevision> gxmxRevs, String opNum, String opName) {
		this.meopLine = meopLine;
		this.gxmxRevs = gxmxRevs;
		this.opNum = opNum;
		this.opName = opName;
	}
	
	public TCComponentBOPLine getMeopLine() {
		return meopLine;
	}

	public List<TCComponentItemRevision> getGxmxRevs() {
		return gxmxRevs;
	}

	public static MeopModelBean parse(TCComponentBOPLine meopLine) throws Exception {
		System.out.println("check line: " + meopLine);
		if (meopLine == null) {
			return null;
		}
		TCComponentItem meopItem = meopLine.getItem();
		if (meopItem == null) {
			System.out.println(">> get item failed");
			return null;
		}
		TCComponentItemRevision meopRev = meopLine.getItemRevision();
		if(meopRev==null) {
			System.out.println(">> get itemrevision failed");
			return null;
		}
		if (!ProcessUtil.isMEOP(meopItem.getType())) {
			System.out.println(">> not meop");
			return null;
		}
		AIFComponentContext[] cc = meopLine.getChildren();
		List<TCComponentItemRevision> gxmxRevs = new ArrayList<TCComponentItemRevision>();
		int len = KUtil.getLen(cc);
		for (int i = 0; i < len; i++) {
			TCComponentBOPLine cLine = (TCComponentBOPLine) cc[i].getComponent();
			TCComponentItemRevision cRev = cLine.getItemRevision();
			String cType = cRev == null ? "" : cRev.getItem().getType();
			System.out.println(">> " + cRev + "|" + cType);
			if (DesignModelOperation.TYPE_ITEM.equals(cType)) {
				gxmxRevs.add(cRev);
			}
		}
		if (gxmxRevs.size()==0) {
			System.out.println(">> no gxmx");
			return null;
		}
		String opNum = meopRev.getRelatedComponent("IMAN_master_form_rev").getStringProperty("ac5_OperationNumber");
		String opName = meopRev.getStringProperty("object_name");
		return new MeopModelBean(meopLine, gxmxRevs, opNum, opName);
	}

	public Object[] getRowData() {
		return new Object[] {this, opName};
	}
	
	@Override
	public String toString() {
		return opNum;
	}
}
