package cn.net.connor.process.meopmodel;

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.table.DefaultTableModel;

import com.teamcenter.rac.util.MessageBox;
import com.teamcenter.rac.util.Registry;

import k.KDialog;
import k.KDialogController;

@SuppressWarnings("serial")
public class MeopModelDialog extends KDialog{
	private static final Registry REG = Registry.getRegistry(MeopModelDialog.class);
	private MeopModelDialogController controller;
	private JButton b_ok;
	private JButton b_cancel;
	protected DefaultTableModel tableModel;
	protected JTable table;
	public MeopModelDialog(KDialogController controller) {
		super(controller);
		this.controller = (MeopModelDialogController)controller;
	}

	@Override
	protected void addListeners() {
		b_ok.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent arg0) {
				try {
					controller.doCreate();
				} catch (Exception e) {
					e.printStackTrace();
					MessageBox.post(MeopModelDialog.this, e);
				}
			}
		});
		b_cancel.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				disposeDialog();
			}
		});
	}

	@Override
	protected void initUI() {
		this.setTitle("");
		// this.setPreferredSize(new Dimension(300, 300));
		this.setLayout(new BorderLayout());
		this.add(BorderLayout.CENTER, initTablePanel());
		this.add(BorderLayout.SOUTH, initBtnPanel());
	}

	private Component initBtnPanel() {
		JPanel panel = new JPanel(new FlowLayout(FlowLayout.CENTER, 25, 5));
		panel.add(b_ok = new JButton(REG.getString("ok.BTN")));
		panel.add(b_cancel = new JButton(REG.getString("cancel.BTN")));
		return panel;
	}

	private Component initTablePanel() {
		JPanel panel = new JPanel(new BorderLayout());
		panel.setBorder(BorderFactory.createEmptyBorder(5, 5, 0, 5));
		this.tableModel = new DefaultTableModel();
		this.table = new JTable(tableModel) {
			public boolean isCellEditable(int row, int column) {
				return false;
			};
		};
		this.table.getTableHeader().setReorderingAllowed(false);
		this.table.setRowHeight(23);
		String[] header = new String[] {REG.getString("opnum.COL"), REG.getString("opname.COL")};
		this.tableModel.setDataVector(null, header);
		JScrollPane scroll = new JScrollPane(table);
		panel.add(BorderLayout.CENTER, scroll);
		int rowCnt = controller.meopModelBeans.size();
		for(int i=0;i<rowCnt;i++) {
			this.tableModel.addRow(controller.meopModelBeans.get(i).getRowData());
		}
		this.table.getColumnModel().getColumn(0).setPreferredWidth(120);
		this.table.getColumnModel().getColumn(1).setPreferredWidth(240);
		return panel;
	}

}
