package cn.net.connor.process.meopviewfx.ui;

import java.util.ArrayList;
import java.util.List;

import com.teamcenter.rac.aif.kernel.AIFComponentContext;
import com.teamcenter.rac.kernel.TCComponent;
import com.teamcenter.rac.kernel.TCComponentBOMLine;
import com.teamcenter.rac.kernel.TCComponentBOMLineType;
import com.teamcenter.rac.kernel.TCComponentItem;
import com.teamcenter.rac.kernel.TCComponentItemRevision;
import com.teamcenter.rac.kernel.TCComponentItemRevisionType;
import com.teamcenter.rac.kernel.TCComponentItemType;
import com.teamcenter.rac.kernel.TCComponentListOfValues;
import com.teamcenter.rac.kernel.TCComponentType;
import com.teamcenter.rac.kernel.TCPropertyDescriptor;
import com.teamcenter.rac.treetable.SwingTextContextActivator;

import cn.net.connor.process.ProcessLocale;
import cn.net.connor.process.Processknowledgebase.SJJHCommand;
import cn.net.connor.process.meopviewfx.bean.KTableRow;
import cn.net.connor.process.meopviewfx.bean.PropConfig;
import javafx.application.Platform;
import javafx.beans.property.SimpleStringProperty;
import javafx.beans.value.ChangeListener;
import javafx.beans.value.ObservableValue;
import javafx.collections.FXCollections;
import javafx.collections.ObservableList;
import javafx.event.EventHandler;
import javafx.scene.control.Control;
import javafx.scene.control.TableCell;
import javafx.scene.control.TableColumn;
import javafx.scene.control.TableRow;
import javafx.scene.control.TableView;
import javafx.scene.control.cell.ComboBoxTableCell;
import javafx.scene.input.MouseEvent;
import javafx.util.Callback;
import k.ui.KFXEditableStringAreaTableCell;
import k.ui.KFXTextLocator;
import k.util.KChineseSpliter;
import k.util.KUtil;

public class TableLoader extends KFXTextLocator {

	protected List<PropConfig> propConfigs = new ArrayList<PropConfig>();
	private TableView<KTableRow> table;
	protected TCComponentItemType itemType;
	protected TCComponentItemRevisionType revType;
	protected TCComponentType itemMasterType;
	protected TCComponentType revMasterType;
	// protected List<KTableRow> newRows = new ArrayList<KTableRow>();
	protected List<KTableRow> removeRows = new ArrayList<KTableRow>();
	protected PropConfig sequenceConfig1 = null;
	protected int maxSeqNo1 = 0;
	protected PropConfig sequenceConfig2 = null;
	protected int maxSeqNo2 = 0;
	protected String[] gdtPropNames;
	private TableColumn<KTableRow, String> nameCol;
	private TableColumn<KTableRow, String> mkhIdCol;
	private TableColumn<KTableRow, String> mkhRevCol;
	public static final String PREF_GDT_PROP = "GDT_properties";
	
	public static Control currentControlSearch;
	public static int currentCaretSearch=0;
	
	

	public boolean load(TableView<KTableRow> table, String prefName) throws Exception {
		this.table = table;
		//+++
		this.table.setOnMouseExited(new EventHandler<MouseEvent>() {
            @Override
            public void handle(MouseEvent event) {
				//双击
//                if (event.getClickCount() == 2
//                		 ||event.getClickCount() == 1) {
                	currentControlSearch=getCurrentControl();
                	currentCaretSearch=currentCaret;
                	System.out.println("+++++"+currentCaretSearch);
                //}
            }
        });
		this.table.focusedProperty().addListener(new ChangeListener<Boolean>() {
			@Override
			public void changed(ObservableValue<? extends Boolean> paramObservableValue, Boolean oldValue, Boolean newValue) {
				if (newValue) {
					SwingTextContextActivator.instance().activateContext();
				} else {
					SwingTextContextActivator.instance().deactivateContext();
				}
			}
		});
		//+++
		clearLocatorData();
		Platform.runLater(() -> {
			table.getColumns().clear();
			table.getItems().clear();
		});
		propConfigs.clear();
		sequenceConfig1 = null;
		sequenceConfig2 = null;
		if (KUtil.isEmpty(prefName)) {
			return false;
		}
		System.out.println("Load table from pref: " + prefName);
		String[] prefVals = KUtil.getPrefVals(KUtil.session, prefName);
		int len = KUtil.getLen(prefVals);
		if (len <= 1) {
			return false;
		}
		String itemTypeName = prefVals[0];
		System.out.println(">> Item Type: " + itemTypeName);
		TCComponentBOMLineType boplineType = null;
		itemType = null;
		revType = null;
		itemMasterType = null;
		revMasterType = null;
		boplineType = (TCComponentBOMLineType) KUtil.session.getTypeComponent("BOMLine");
		if (boplineType == null) {
			throw new Exception("Type not found: BOPLine");
		}
		if (!KTableRow.BOMLINE.equalsIgnoreCase(itemTypeName)) {
			itemType = (TCComponentItemType) KUtil.session.getTypeComponent(itemTypeName);
			if (itemType == null) {
				throw new Exception(String.format(ProcessLocale.getString("typenotfound.ERROR1"), itemTypeName));
			}
			revType = itemType.getItemRevisionType();
			itemMasterType = KUtil.session.getTypeComponent(itemTypeName + "Master");
			if (itemMasterType == null) {
				itemMasterType = KUtil.session.getTypeComponent(itemTypeName + " Master");
			}
			if (itemMasterType == null) {
				throw new Exception(String.format(ProcessLocale.getString("typenotfound.ERROR1"), itemTypeName + "Master"));
			}
			revMasterType = KUtil.session.getTypeComponent(revType.getTypeName() + "Master");
			if (revMasterType == null) {
				revMasterType = KUtil.session.getTypeComponent(revType.getTypeName() + " Master");
			}
			if (revMasterType == null) {
				throw new Exception(String.format(ProcessLocale.getString("typenotfound.ERROR1"), revType.getTypeName() + "Master"));
			}
		}
		for (int i = 1; i < len; i++) {
			String propName = prefVals[i];
			System.out.println("Load Config: " + propName);
			if (KUtil.isEmpty(propName)) {
				continue;
			}
			String propLoc = null;
			String filterValue = null;
			int width = 0;
			int maxCharacter = 0;
			if ('-' == propName.charAt(0)) {
				width = -1;
				propName = propName.substring(1);
			} else {
				while (!KUtil.isEmpty(propName) && Character.isDigit(propName.charAt(0))) {
					width = width * 10 + (propName.charAt(0) - '0');
					propName = propName.substring(1);
				}
				if (propName.startsWith("$")) {
					propName = propName.substring(1);
					while (!KUtil.isEmpty(propName) && Character.isDigit(propName.charAt(0))) {
						maxCharacter = maxCharacter * 10 + (propName.charAt(0) - '0');
						propName = propName.substring(1);
					}
				}
			}
			int ind = propName.indexOf('.');
			if (ind > 0) {
				propLoc = propName.substring(0, ind);
				propName = propName.substring(ind + 1);
			}
			ind = propName.indexOf('=');
			if (ind > 0) {
				filterValue = propName.substring(ind + 1);
				propName = propName.substring(0, ind);
			}
			// System.out.println(propName + "|" + filterValue);
			TCComponentType type = null;
			if (KUtil.isEmpty(propLoc)) {
				type = boplineType;
				propLoc = KTableRow.BOMLINE;
			} else {
				switch (propLoc.toUpperCase()) {
				case KTableRow.BOMLINE:
					type = boplineType;
					break;
				case KTableRow.ITEM:
					type = itemType;
					break;
				case KTableRow.REV:
					type = revType;
					break;
				case KTableRow.ITEMMASTER:
					type = itemMasterType;
					break;
				case KTableRow.REVMASTER:
					type = revMasterType;
					break;
				default:
					System.out.println(">> Prop location error: " + propLoc);
					break;
				}
			}
			if (type != null) {
				TCPropertyDescriptor propDesc = type.getPropDesc(propName);
				if (propDesc == null) {
					throw new Exception(String.format(ProcessLocale.getString("propnotdefinedintype.ERROR2"), propName, type.getDisplayTypeName()));
				}
				this.propConfigs.add(new PropConfig(propLoc, propDesc, filterValue, width, maxCharacter));
			}
		}
		System.out.println("Load complete");
		int size = this.propConfigs.size();
		if (size == 0) {
			return false;
		}
		this.gdtPropNames = KUtil.getPrefVals(KUtil.session, PREF_GDT_PROP);
		for (int i = 0; i < size; i++) {
			PropConfig config = propConfigs.get(i);
			if ("bl_sequence_no".equals(config.propName)) {
				this.sequenceConfig1 = config;
			} else if (KTableRow.REVMASTER.equalsIgnoreCase(config.propLoc) && "ac5_WorkstepNumber".equals(config.propName)) { // TODO ac5_WorkstepNumber
				this.sequenceConfig2 = config;
			}
			addTableCol(table, config);
		}
		// Platform.runLater(()->{
		//
		// KTableRow row = new KTableRow();
		// for (PropConfig string : propConfigs) {
		// row.stringProps.put(string, new
		// SimpleStringProperty(string.lov!=null?"":string.propName));
		// }
		// table.getItems().add(row);
		// });
		return true;
	}

	public KTableRow getNewRow() {
		KTableRow row = new KTableRow(null, null, null, null, null);
		for (PropConfig propConfig : propConfigs) {
			row.stringProps.put(propConfig, new SimpleStringProperty(""));
		}
		return row;
	}

	public void loadTCData(TCComponentBOMLine targetLine, boolean useLatestRev) throws Exception {
		Platform.runLater(() -> {
			table.getItems().clear();
		});
		if (targetLine == null) {
			return;
		}
		int size = this.propConfigs.size();
		if (size == 0) {
			return;
		}
		removeRows.clear();
		maxSeqNo1 = 0;
		maxSeqNo2 = 0;
		AIFComponentContext[] cc = targetLine.getChildren();
		int len = KUtil.getLen(cc);
		for (int i = 0; i < len; i++) {
			TCComponentBOMLine bomine = (TCComponentBOMLine) cc[i].getComponent();
			String seq = bomine.getStringProperty("bl_sequence_no");
			if (!KUtil.isEmpty(seq)) {
				try {
					int seqNum = Integer.parseInt(seq);
					seqNum = seqNum / 10;
					if (seqNum > maxSeqNo1) {
						maxSeqNo1 = seqNum;
					}
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			TCComponentItem item = bomine.getItem();
			if (this.itemType != null && !this.itemType.getName().equals(item.getType())) {
				continue;
			}
			TCComponentItemRevision rev = useLatestRev ? item.getLatestItemRevision() : bomine.getItemRevision();
			TCComponent itemMaster = item.getRelatedComponent("IMAN_master_form");
			TCComponent revMaster = rev.getRelatedComponent("IMAN_master_form_rev");
			KTableRow row = new KTableRow(bomine, item, rev, itemMaster, revMaster);
			boolean checkOK = true;
			for (int j = 0; j < size; j++) {
				PropConfig config = propConfigs.get(j);
				if (!row.parseConfig(config)) {
					checkOK = false;
					break;
				}
			}
			if (checkOK) {
				if (this.sequenceConfig2 != null) {
					String seq2 = row.getTCValue(this.sequenceConfig2.propLoc, this.sequenceConfig2.propName);
					if (!KUtil.isEmpty(seq2)) {
						try {
							int seqNum = Integer.parseInt(seq2);
							if (seqNum > maxSeqNo2) {
								maxSeqNo2 = seqNum;
							}
						} catch (Exception e) {
							e.printStackTrace();
						}
					}
				}
				Platform.runLater(() -> {
					table.getItems().add(row);
				});
			}
		}
		maxSeqNo1++;
		maxSeqNo2++;
		System.out.println("Max Sequence: " + maxSeqNo1 + " and " + maxSeqNo2);
	}

	public void saveTCData(TCComponentBOMLine parentLine) throws Exception {
		while (removeRows.size() > 0) {
			removeRows.get(0).removeLine(parentLine);
			removeRows.remove(0);
		}
		KTableRow[] rows = table.getItems().toArray(new KTableRow[] {});
		int len = KUtil.getLen(rows);
		for (int i = 0; i < len; i++) {
			KTableRow row = rows[i];
			row.saveTCData(parentLine, itemType);
		}
	}

	public void addRow() {
		KTableRow row = getNewRow();
//		if (sequenceConfig1 != null) {
//			row.stringProps.get(sequenceConfig1).setValue("" + (maxSeqNo1 * 10));
//			maxSeqNo1++;
//		}
//		if (sequenceConfig2 != null) {
//			row.stringProps.get(sequenceConfig2).setValue("" + maxSeqNo2);
//			maxSeqNo2++;
//		}
		table.getItems().add(row);
		table.getSelectionModel().select(row);
		table.scrollTo(row);
		resetSequence();
	}

	public void removeRow() {
		KTableRow row = table.getSelectionModel().getSelectedItem();
		System.out.println("Remove: " + table.getSelectionModel().getSelectedIndex());
		if (row == null) {
			return;
		}
		table.getItems().remove(row);
		removeRows.add(row);
		resetSequence();
	}

	public void resetSequence() {
		if (sequenceConfig1 == null && sequenceConfig2 == null) {
			return;
		}
		int rowCnt = table.getItems().size();
		for (int i = 0; i < rowCnt; i++) {
			int seq = i + 1;
			KTableRow row = table.getItems().get(i);
			if (sequenceConfig1 != null) {
				row.stringProps.get(sequenceConfig1).setValue("" + (seq * 10));
			}
			if (sequenceConfig2 != null) {
				row.stringProps.get(sequenceConfig2).setValue("" + seq);
			}
		}
		maxSeqNo1 = rowCnt + 1;
		maxSeqNo2 = rowCnt + 1;
	}

	public void moveUp() {
		int index = table.getSelectionModel().getSelectedIndex();
		System.out.println("Move UP: " + index);
		if (index <= 0) {
			return;
		}
		KTableRow item = table.getItems().get(index);
		KTableRow sideItem = table.getItems().get(index - 1);
		if (sequenceConfig1 != null) {
			String itemSeq = item.stringProps.get(sequenceConfig1).getValueSafe();
			String sideItemSeq = sideItem.stringProps.get(sequenceConfig1).getValueSafe();
			item.stringProps.get(sequenceConfig1).setValue(sideItemSeq);
			sideItem.stringProps.get(sequenceConfig1).setValue(itemSeq);
		}
		if (sequenceConfig2 != null) {
			String itemSeq = item.stringProps.get(sequenceConfig2).getValueSafe();
			String sideItemSeq = sideItem.stringProps.get(sequenceConfig2).getValueSafe();
			item.stringProps.get(sequenceConfig2).setValue(sideItemSeq);
			sideItem.stringProps.get(sequenceConfig2).setValue(itemSeq);
		}
		table.getItems().remove(item);
		table.getItems().add(index - 1, item);
		table.getSelectionModel().clearAndSelect(index - 1);
	}

	public void moveDown() {
		int index = table.getSelectionModel().getSelectedIndex();
		System.out.println("Move Down: " + index);
		if (index >= table.getItems().size() - 1) {
			return;
		}
		KTableRow item = table.getItems().get(index);
		KTableRow sideItem = table.getItems().get(index + 1);
		if (sequenceConfig1 != null) {
			String itemSeq = item.stringProps.get(sequenceConfig1).getValueSafe();
			String sideItemSeq = sideItem.stringProps.get(sequenceConfig1).getValueSafe();
			item.stringProps.get(sequenceConfig1).setValue(sideItemSeq);
			sideItem.stringProps.get(sequenceConfig1).setValue(itemSeq);
		}
		if (sequenceConfig2 != null) {
			String itemSeq = item.stringProps.get(sequenceConfig2).getValueSafe();
			String sideItemSeq = sideItem.stringProps.get(sequenceConfig2).getValueSafe();
			item.stringProps.get(sequenceConfig2).setValue(sideItemSeq);
			sideItem.stringProps.get(sequenceConfig2).setValue(itemSeq);
		}
		table.getItems().remove(item);
		table.getItems().add(index + 1, item);
		table.getSelectionModel().clearAndSelect(index + 1);
	}

	public void search(TCComponentBOMLine target) {
		
		//EventDispatcher ss	=table.get;
		//String string=	table.getColumns().get(2).getTypeSelector;
//		//System.out.println("------>"+ss.dispatchEvent(arg0, arg1));
//		insertText("test");
//		
//		
			//System.out.println("名称==>"+target.getItemRevision().getStringProperty("object_name"));
			new Thread(new SJJHCommand(target,table,propConfigs)).start();
			
//			//
//			int index = table.getSelectionModel().getSelectedIndex();
//			KTableRow item = table.getItems().get(index);
//			for (int i = 0; i < this.propConfigs.size(); i++) {
//				if(propConfigs.get(i).propName.equals("ac5_ActivityCont")) {
//					PropConfig config = propConfigs.get(i);
//					String ActivityCont = item.stringProps.get(config).getValue();
//					item.stringProps.get(config).setValue(ActivityCont+"\n"+"test");
//					//itemSeq="";
//					break;
//				}
//			}
	}
	
	
	
	private void addTableCol(TableView<KTableRow> table, PropConfig config) throws Exception {
		String header = config.propDisplayName;
		TCComponentListOfValues lov = config.lov;
		// gdt properties
		if (!KUtil.isEmpty(config.propName) && KUtil.inArray(config.propName, gdtPropNames) >= 0) {
			TableColumn<KTableRow, String> c = new TableColumn<KTableRow, String>(header);
			c.setCellValueFactory(p -> p.getValue().stringProps.get(config));
			c.setCellFactory(new Callback<TableColumn<KTableRow, String>, TableCell<KTableRow, String>>() {
				@Override
				public TableCell<KTableRow, String> call(TableColumn<KTableRow, String> param) {
					return new KFXEditableStringAreaHtmlTableCell<KTableRow, String>(config);
				}
			});
			if (config.width > 0) {
				c.setPrefWidth(config.width);
			} else if (config.width < 0) {
				c.setMinWidth(0);
				c.setMaxWidth(0);
				c.setPrefWidth(0);
			}
			Platform.runLater(() -> {
				c.setSortable(false);
				c.setEditable(config.canEdit);
				table.getColumns().add(c);
			});
			return;
		}
		if (lov == null) {
			TableColumn<KTableRow, String> c = new TableColumn<KTableRow, String>(header);
			if ("object_name".equals(config.propName) && "rev".equalsIgnoreCase(config.propLoc)) { // kk 20210324 閸婃帗鏆熺粭顑跨癌鐞涘苯鍟撻柆鎾跺閺堫剙鐫橀幀顪礲ject_name
				this.nameCol = c;
			}else if("ac5_MKHGYBH".equals(config.propName) && "revmaster".equalsIgnoreCase(config.propLoc)) { // kk 20211214 id閸滃瞼澧楅張顒�寮介崘锟�
				this.mkhIdCol = c;
			}else if("ac5_MKHGYBB".equals(config.propName) && "revmaster".equalsIgnoreCase(config.propLoc)) { // kk 20211214 id閸滃瞼澧楅張顒�寮介崘锟�
				this.mkhRevCol = c;
			}
			c.setCellValueFactory(p -> p.getValue().stringProps.get(config));
			c.setCellFactory(new Callback<TableColumn<KTableRow, String>, TableCell<KTableRow, String>>() {
				@Override
				public TableCell<KTableRow, String> call(TableColumn<KTableRow, String> param) {
					KFXEditableStringAreaTableCell<KTableRow, String> cell = new KFXEditableStringAreaTableCell<KTableRow, String>(TableLoader.this) {
						public void commitEdit(String item) {
							if (config.maxCharacterInRow > 0 && item != null) {
								String newValue = item.replace("\r", "");
								String[] split = newValue.split("\n", -1);
								StringBuilder sb = new StringBuilder();
								for (int i = 0; i < split.length; i++) {
									String s = split[i];
									if (i > 0) {
										sb.append("\n");
									}
									List<String> csplit = KChineseSpliter.getDivideVals(s, config.maxCharacterInRow, "\n");
									for (int j = 0; j < csplit.size(); j++) {
										if (j > 0) {
											sb.append("\r");
										}
										sb.append(csplit.get(j));
									}
									// while (s.length() > config.maxCharacterInRow) {
									// sb.append(s.substring(0, config.maxCharacterInRow)).append("\r");
									// s = s.substring(config.maxCharacterInRow);
									// insertPos.add(sb.length() - 1);
									// }
									// sb.append(s);
								}
								item = sb.toString();
								System.out.println("=====================\n" + newValue + "\n>>\n" + item + "\n\"=====================");
							}
							super.commitEdit(item);
						};
					};
					//TODO 
					cell.focusedProperty().addListener(new ChangeListener<Boolean>() {
						@Override
						public void changed(ObservableValue<? extends Boolean> paramObservableValue, Boolean oldValue, Boolean newValue) {
							System.out.println("cell.focusedProperty().addListener.changed()");
							if (newValue) {
								SwingTextContextActivator.instance().activateContext();
							} else {
								SwingTextContextActivator.instance().deactivateContext();
							}
						}
					});
					System.out.println("cell.focusedProperty().addListener");
					return cell;
				}
			});
			if (config.width > 0) {
				c.setPrefWidth(config.width);
			} else if (config.width < 0) {
				c.setMinWidth(0);
				c.setMaxWidth(0);
				c.setPrefWidth(0);
			}
			Platform.runLater(() -> {
				c.setSortable(false);
				c.setEditable(config.canEdit);
				table.getColumns().add(c);
			});
		} else {
			ObservableList<String> options = FXCollections.observableArrayList();
			String[] disVals = lov.getListOfValues().getLOVDisplayValues();
			options.add("");
			for (String string : disVals) {
				options.add(string);
			}
			TableColumn<KTableRow, String> c = new TableColumn<KTableRow, String>(header);
			c.setCellValueFactory(p -> p.getValue().stringProps.get(config));
			c.setCellFactory(new Callback<TableColumn<KTableRow, String>, TableCell<KTableRow, String>>() {

				@Override
				@SuppressWarnings("unchecked")
				public TableCell<KTableRow, String> call(TableColumn<KTableRow, String> param) {

					return new ComboBoxTableCell<KTableRow, String>(null, options) {
						@Override
						public void updateItem(String t, boolean bl) {
							super.updateItem(t, bl);
							if (KUtil.isEmpty(t)) {
								return;
							}
							System.out.println("Update LOV Item: " + t);
							TableRow<KTableRow> row = getTableRow();
							if (row == null || row.getItem() == null) {
								return;
							}
							KTableRow bean = row.getItem();
							if (bean.stringProps.containsKey(config)) {
								String val = bean.stringProps.get(config).getValueSafe();
								if (!KUtil.isEmpty(val)) {
									try {
										val = KUtil.getLovDisplayableValue(lov, val);
										System.out.println(">> display value: " + val);
										super.updateItem(val, bl);
									} catch (Exception e) {
										e.printStackTrace();
										// MessageBox.post(e);
									}
								}
							}
						}

						@Override
						public void commitEdit(String t) {
							super.commitEdit(t);
							System.out.println("Change LOV value: " + t);
							try {
								TableRow<KTableRow> row = getTableRow();
								if (row == null || row.getItem() == null) {
									return;
								}
								KTableRow bean = row.getItem();
								if (bean.stringProps.containsKey(config)) {
									String realVal = KUtil.getLovValue(lov, t);
									System.out.println(">> real value: " + realVal);
									bean.stringProps.get(config).setValue(realVal);
								}
							} catch (Exception e) {
								e.printStackTrace();
							}
						}

					};
				}
			});
			if (config.width > 0) {
				c.setPrefWidth(config.width);
			}
			Platform.runLater(() -> {
				c.setEditable(config.canEdit);
				c.setSortable(false);
				table.getColumns().add(c);
			});
		}
	}

	@SuppressWarnings("unchecked")
	@Override
	public void insertText(String text) {
		if (KUtil.isEmpty(text)) {
			return;
		}
		
		Control currentControl = getCurrentControl();
		if (currentControl == null) {
			return;
		}
		if (currentControl instanceof KFXEditableStringAreaTableCell) {
			KFXEditableStringAreaTableCell<KTableRow, String> cell = (KFXEditableStringAreaTableCell<KTableRow, String>) currentControl;
			String oldValue = cell.getItem();
			String newValue;
			System.out.println(currentCaret + ":" + oldValue);
			int temp = currentCaret;
			if (oldValue == null) {
				newValue = text;
			} else if (currentCaret >= 0 && currentCaret <= oldValue.length()) {
				newValue = oldValue.substring(0, currentCaret) + text + oldValue.substring(currentCaret);
				currentCaret += text.length();
				temp = currentCaret;
			} else {
				newValue = oldValue + text;
			}
			System.out.println("-> " + newValue);
			cell.commitEdit(newValue);
			table.edit(cell.getTableRow().getIndex(), cell.getTableColumn());
			final int temp2 = temp;
			new Thread(new Runnable() {
				@Override
				public void run() {
					try {
						Thread.sleep(100);
					} catch (Exception e) {
						e.printStackTrace();
					}
					Platform.runLater(() -> {
						cell.startEdit(temp2);
					});
				}
			}).start();
		}
	}

	@SuppressWarnings("unchecked")
	public void insertText(String text, String parentText, String mhkId, String mhkRev) {
		if (KUtil.isEmpty(text)) {
			return;
		}
		Control currentControl = getCurrentControl();
		if (currentControl == null) {
			return;
		}
		if (currentControl instanceof KFXEditableStringAreaTableCell) {
			KFXEditableStringAreaTableCell<KTableRow, String> cell = (KFXEditableStringAreaTableCell<KTableRow, String>) currentControl;
			try {
				System.out.println("Name: " + parentText);
				if (parentText != null && this.nameCol != null && cell.getTableColumn() != this.nameCol) {
					SimpleStringProperty value = (SimpleStringProperty) this.nameCol.getCellObservableValue((KTableRow) (cell.getTableRow().getItem()));
					System.out.println(value);
					value.setValue(parentText);
				}
			} catch (Exception e1) {
				e1.printStackTrace();
			}
			try {
				System.out.println("MKH Id: " + mhkId);
				if (mhkId != null && this.mkhIdCol != null && cell.getTableColumn() != this.mkhIdCol) {
					SimpleStringProperty value = (SimpleStringProperty) this.mkhIdCol.getCellObservableValue((KTableRow) (cell.getTableRow().getItem()));
					System.out.println(value);
					value.setValue(mhkId);
				}
			} catch (Exception e1) {
				e1.printStackTrace();
			}
			try {
				System.out.println("MKH Rev: " + mhkRev);
				if (mhkRev != null && this.mkhRevCol != null && cell.getTableColumn() != this.mkhRevCol) {
					SimpleStringProperty value = (SimpleStringProperty) this.mkhRevCol.getCellObservableValue((KTableRow) (cell.getTableRow().getItem()));
					System.out.println(value);
					value.setValue(mhkRev);
				}
			} catch (Exception e1) {
				e1.printStackTrace();
			}
			String oldValue = cell.getItem();
			String newValue;
			System.out.println(currentCaret + ":" + oldValue);
			int temp = currentCaret;
			if (oldValue == null) {
				newValue = text;
			} else if (currentCaret >= 0 && currentCaret <= oldValue.length()) {
				newValue = oldValue.substring(0, currentCaret) + text + oldValue.substring(currentCaret);
				currentCaret += text.length();
				temp = currentCaret;
			} else {
				newValue = oldValue + text;
			}
			System.out.println("-> " + newValue);
			cell.commitEdit(newValue);
			table.edit(cell.getTableRow().getIndex(), cell.getTableColumn());
			final int temp2 = temp;
			new Thread(new Runnable() {
				@Override
				public void run() {
					try {
						Thread.sleep(100);
					} catch (Exception e) {
						e.printStackTrace();
					}
					Platform.runLater(() -> {
						cell.startEdit(temp2);
					});
				}
			}).start();
		}
	}

}
