package cn.net.connor.process.newmeop;

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.swing.BorderFactory;
import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.ListSelectionModel;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

import com.teamcenter.rac.util.MessageBox;

import cn.net.connor.process.ProcessLocale;
import cn.net.connor.process.newmeop.NewMeopDialogController.MEOPType;
import k.KDialog;
import k.KDialogController;
import k.util.KUtil;

@SuppressWarnings("serial")
public class NewMeopDialog extends KDialog {

	private JButton b_ok;
	private JButton b_cel;
	protected DefaultListModel<MEOPType> lm_type;
	protected JList<MEOPType> l_type;
	private NewMeopDialogController controller;
	private JButton b_assignId;
	private PrefComponent idComponent;
	private Map<PrefComponent,JButton> chooseComponents = new HashMap<PrefComponent, JButton>();
	private PrefComponent sequenceComponent;
//	private JButton b_assignMeopNo;
	private JButton b_insertMeopNo;

	public NewMeopDialog(KDialogController controller) {
		super(controller);
		this.controller = (NewMeopDialogController)controller;
	}
	
	private void setCompEnabled(boolean b) {
		b_ok.setEnabled(b);
		b_cel.setEnabled(b);
		for (JButton btn : chooseComponents.values()) {
			btn.setEnabled(b);
		}
	}
	
	public void setAssignId(String newId) {
		if(idComponent!=null&&b_assignId!=null) {
			if(KUtil.isEmpty(newId)) {
				idComponent.setValue(null);
				b_assignId.setEnabled(true);
			}else {
				idComponent.setValue(newId);
				b_assignId.setEnabled(false);
			}
		}
	}
	
	public void setMeopNo(String newId) {
		if(sequenceComponent!=null && b_insertMeopNo!=null) {//&&b_assignMeopNo!=null
			if(KUtil.isEmpty(newId)) {
				sequenceComponent.setValue(null);
//				b_assignMeopNo.setEnabled(true);
//				b_insertMeopNo.setEnabled(true);
			}else {
				sequenceComponent.setValue(newId);
//				b_assignMeopNo.setEnabled(false);
//				b_insertMeopNo.setEnabled(false);
			}
		}
	}

	@Override
	protected void addListeners() {
		b_ok.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				new Thread(new Runnable() {
					@Override
					public void run() {
						setCompEnabled(false);
						try {
							controller.doCreate();
							controller.assignMeopNo();
						} catch (Exception e) {
							e.printStackTrace();
							MessageBox.post(NewMeopDialog.this,e);
						}
						setCompEnabled(true);
					}
				}).start();
			}
		});
		b_cel.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				disposeDialog();
			}
		});
		if(b_assignId!=null&&idComponent!=null) {
			b_assignId.addActionListener(new ActionListener() {
				@Override
				public void actionPerformed(ActionEvent e) {
					try {
						controller.assignId();
					} catch (Exception e1) {
						e1.printStackTrace();
						MessageBox.post(NewMeopDialog.this,e1);
					}
				}
			});
		}
		if(this.sequenceComponent!=null && this.b_insertMeopNo!=null) {
//			b_assignMeopNo.addActionListener(new ActionListener() {
//				@Override
//				public void actionPerformed(ActionEvent e) {
//					try {
//						controller.assignMeopNo();//TODO 
//					} catch (Exception e1) {
//						e1.printStackTrace();
//						MessageBox.post(NewMeopDialog.this,e1);
//					}
//				}
//			});
			b_insertMeopNo.addActionListener(new ActionListener() {
				@Override
				public void actionPerformed(ActionEvent e) {
					try {
						controller.insertMeopNo();
					} catch (Exception e1) {
						e1.printStackTrace();
						MessageBox.post(NewMeopDialog.this,e1);
					}
				}
			});
		}
		for (PrefComponent bean : chooseComponents.keySet()) {
			JButton btn = chooseComponents.get(bean);
			btn.addActionListener(new ActionListener() {
				@Override
				public void actionPerformed(ActionEvent e) {
					MEOPType typeComp = l_type.getSelectedValue();
					if (typeComp == null) {
						KUtil.warn(NewMeopDialog.this, ProcessLocale.getString("selectMeopType.INFO"));
						return;
					}
					bean.performChoose(NewMeopDialog.this, typeComp.type, controller.getApp(), controller.prefComponents);
				}
			});
			
		}
		this.l_type.addListSelectionListener(new ListSelectionListener() {
			@Override
			public void valueChanged(ListSelectionEvent arg0) {
				if(arg0.getValueIsAdjusting()) {
					return;
				}
				System.out.println("Select Type Change > "+l_type.getSelectedValue());
				setAssignId(null);
				setMeopNo(null);
				try {
					controller.assignMeopNo();//TODO 
				} catch (Exception e1) {
					e1.printStackTrace();
					MessageBox.post(NewMeopDialog.this,e1);
				}
				if(controller.shortDescPrefComp!=null&&l_type.getSelectedValue()!=null) {
					controller.shortDescPrefComp.setValue(l_type.getSelectedValue().additional);
				}
			}
		});

	}

	@Override
	protected void initUI() {
		this.setTitle(ProcessLocale.getString("newmeop.TITLE"));
		this.setPreferredSize(new Dimension(780, 640));
		this.setMinimumSize(new Dimension(780, 640));
		this.setLayout(new BorderLayout());
		this.add(BorderLayout.WEST, initTypePanel());
		this.add(BorderLayout.CENTER, initPropPanel());
		this.add(BorderLayout.SOUTH, initBtnPanel());
	}

	private Component initBtnPanel() {
		JPanel panel = new JPanel(new FlowLayout(FlowLayout.CENTER, 20, 5));
		this.b_ok = new JButton(ProcessLocale.getString("ok"));
		this.b_cel = new JButton(ProcessLocale.getString("cancel"));
		panel.add(b_ok);
		panel.add(b_cel);
		return panel;
	}

	private Component initPropPanel() {
		JPanel panel = new JPanel(new BorderLayout());
		panel.add(BorderLayout.CENTER, initMEPropPanel());
		panel.add(BorderLayout.SOUTH, initDESCPropPanel());
		return panel;
	}

	private Component initDESCPropPanel() {
		JPanel panel = new JPanel(new BorderLayout());
		if(controller.shortDescPrefComp!=null) {
			//panel.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEmptyBorder(30, 5, 5, 5), ProcessLocale.getString("medesc.TITLE")));
			panel.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEmptyBorder(30, 5, 5, 5), controller.shortDescPrefComp.getLabel().getText()));
			JScrollPane scroll = new JScrollPane(controller.shortDescPrefComp.getValueComp());
			panel.add(BorderLayout.CENTER, scroll);
			controller.prefComponents.add(controller.shortDescPrefComp);
		}
		return panel;
	}

	private Component initMEPropPanel() {
		JPanel wrapper = new JPanel(new BorderLayout());
		wrapper.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEmptyBorder(30, 5, 5, 5), ProcessLocale.getString("meinfo.TITLE")));
		JPanel panel = new JPanel(new GridBagLayout());
		panel.setBorder(BorderFactory.createEmptyBorder(20,30,20,30));
		GridBagConstraints s = getGridBagConstraints(0, 0, new Insets(6, 6, 6, 6));
		List<PrefComponent> comps = controller.prefComponents;
		int colCnt = 1;
		int size = comps.size();
		for(int i=0;i<size;i++) {
			PrefComponent prefComponent = comps.get(i);
			if(i%colCnt==0) {
				KUtil.newRow(panel, prefComponent.label, s, 1);
			}else {
				KUtil.addCol(panel, prefComponent.label, s, 1, 0);
			}
			KUtil.addCol(panel, prefComponent.getValueComp(), s, 1, 1);
			if("item.item_id".equals(prefComponent.propConfig.toLowerCase())) {
				KUtil.addCol(panel, this.b_assignId = new JButton(ProcessLocale.getString("assign")), s, 1, 0); 
				this.idComponent = prefComponent;
			}else if(KUtil.getLen(prefComponent.chooseFromExcel)>0) {
				JButton b_choose = new JButton(ProcessLocale.getString("select"));
				KUtil.addCol(panel, b_choose, s, 1, 0);
				chooseComponents.put(prefComponent, b_choose);
			}else if("revmaster.ac5_OperationNumber".equalsIgnoreCase(prefComponent.propConfig)) {
//				KUtil.addCol(panel,this.b_assignMeopNo = new JButton(ProcessLocale.getString("shenqing")), s, 1, 0);//TODO
				KUtil.addCol(panel,this.b_insertMeopNo = new JButton(ProcessLocale.getString("insert")), s, 1, 0);
				this.sequenceComponent = prefComponent;
				try {
					controller.assignMeopNo(); 
				} catch (Exception e1) {
					e1.printStackTrace();
					MessageBox.post(NewMeopDialog.this,e1);
				}
			}
		}
		s.weighty = 1;
		KUtil.newRow(panel, new JLabel(""), s, 1);
		JScrollPane scroll = new JScrollPane(panel);
		//scroll.setBorder(null);
		wrapper.add(BorderLayout.CENTER, scroll);
		return wrapper;
	}

	private Component initTypePanel() {
		JPanel panel = new JPanel(new BorderLayout());
		panel.setPreferredSize(new Dimension(200,0));
		panel.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEmptyBorder(30, 5, 5, 0), ProcessLocale.getString("meoptype.TITLE")));
		this.lm_type = new DefaultListModel<MEOPType>();
		this.l_type = new JList<MEOPType>(lm_type);
		for (MEOPType t : controller.meopTypes) {
			this.lm_type.addElement(t);
		}
		this.l_type.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		JScrollPane scroll = new JScrollPane(this.l_type);
		panel.add(BorderLayout.CENTER, scroll);
		return panel;
	}

}
