package cn.net.connor.process.newmeop;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.swing.JComponent;
import javax.swing.JLabel;

import com.teamcenter.rac.aif.AbstractAIFApplication;
import com.teamcenter.rac.aif.AbstractAIFDialog;
import com.teamcenter.rac.kernel.TCComponentItemRevision;
import com.teamcenter.rac.kernel.TCComponentListOfValues;
import com.teamcenter.rac.kernel.TCSession;
import com.teamcenter.rac.util.iTextArea;
import com.teamcenter.rac.util.iTextField;
import com.teamcenter.rac.util.combobox.iComboBox;
import com.teamcenter.soa.client.model.LovValue;

import cn.net.connor.process.ProcessLocale;
import cn.net.connor.process.choose.ChooseDialog;
import cn.net.connor.process.choose.ChooseDialogController;
import k.util.KUtil;

public class PrefComponent {

	public static final String REQUIRE = "*";
	public static final String READONLY = "#";
	public static final String TEXTAREA = "$";
	public static final String SCYYJCX = "@";
	

	private String configStr;
	protected boolean require = false;
	protected boolean readonly = false;
	protected String title;
	protected String propConfig;
	protected String lovName;
	private String[] additional;
	private String[] lov;
	private String[] displayLov;
	private iTextField textField;
	private iTextArea textArea;
	private iComboBox comboBox;
	protected JLabel label;
	protected String[] chooseFromExcel;
	//private Map<String, ChooseDialog> chooseDialogMap = new HashMap<String, ChooseDialog>();
	protected boolean isTextArea = false;
	private String savedValue;
	private String fromProcess;
	private String fromProcessValue;
	private String propName;
	private String displayCondition;
	private List<JComponent> additionalComps = new ArrayList<JComponent>();
	private boolean isScyyj = false;
	
	public String[] getExcelConfig() {
		return this.chooseFromExcel;
	}
	
	public String getTitle() {
		return title;
	}
	
	public boolean canDisplay(TCComponentItemRevision rev) throws Exception{
		if(KUtil.isEmpty(displayCondition)||rev==null) {
			return true;
		}
		System.out.println("Check Property Display: "+rev+" -> "+displayCondition);
		int ind = displayCondition.lastIndexOf(':');
		if(ind<0) {
			return true;
		}
		String propStr = displayCondition.substring(0, ind);
		String checkValue = displayCondition.substring(ind+1);
		String propValue = KUtil.getConfigPropValue(rev, propStr);
		System.out.println("Prop Value: "+propValue);
		return checkValue.equals(propValue);
	}

	public String getPropConfig() {
		return propConfig;
	}

	public PrefComponent(String pref) {
		this.configStr = pref;
	}
	
	public boolean init(TCSession session) throws Exception{
		return init(session, null, null);
	}

	public boolean init(TCSession session, TCComponentItemRevision targetRev, List<PrefComponent> prefComponents) throws Exception {
		if (KUtil.isEmpty(configStr)) {
			return false;
		}
		System.out.println(configStr);
		if (configStr.startsWith(REQUIRE)) {
			configStr = configStr.substring(1);
			this.require = true;
		}
		if (configStr.startsWith(READONLY)) {
			configStr = configStr.substring(1);
			this.readonly = true;
		}
		if (configStr.startsWith(TEXTAREA)) {
			configStr = configStr.substring(1);
			this.isTextArea = true;
		}
		System.out.println(configStr+">>"+SCYYJCX+">>"+configStr.startsWith(SCYYJCX));
		if (configStr.startsWith(SCYYJCX)) {
			configStr = configStr.substring(1);
			this.isScyyj = true;
		}
		String[] split = configStr.split("=", -1);
		int len = KUtil.getLen(split);
		if (len > 0) {
			this.title = split[0];
		}
		if (len > 1) {
			this.propConfig = split[1];
		}
		if (len > 2) {
			this.lovName = split[2];
		}
		if (len > 3) {
			this.fromProcess = split[3]; 
		}
		if (len > 4) {
			displayCondition = split[4];
		}
		if (KUtil.isEmpty(title)) {
			return false;
		}
		if(!KUtil.isEmpty(fromProcess)) {
			this.fromProcessValue = KUtil.getConfigPropValue(targetRev, fromProcess);
		}
		if (!KUtil.isEmpty(lovName)) {
			int ind = lovName.indexOf(';');
			if(ind>0) {
				String[] lovValues = lovName.split(";");
				int lovCnt = KUtil.getLen(lovValues);
				this.lov = new String[lovCnt];
				this.displayLov = new String[lovCnt];
				for (int i = 0; i < lovCnt; i++) {
					String realValue = lovValues[i];
					String disValue = lovValues[i];
					lov[i] = realValue;
					displayLov[i] = disValue;
				}
			}else {
				TCComponentListOfValues lovComp = KUtil.getLov(lovName);
				if (lovComp == null) {
					throw new Exception(String.format(ProcessLocale.getString("lovnotfound.ERROR1"), lovName));
				}
				if (lovComp.getListOfValues() != null) {
					List<LovValue> vals = lovComp.getListOfValues().getValues();
					int lovCnt = vals == null ? 0 : vals.size();
					this.lov = new String[lovCnt];
					this.displayLov = new String[lovCnt];
					for (int i = 0; i < lovCnt; i++) {
						LovValue lovValue = vals.get(i);
						String realValue = lovValue.getValue() == null ? "" : lovValue.getValue().toString();
						String disValue = lovValue.getDisplayValue();
						lov[i] = realValue;
						displayLov[i] = disValue;
					}
				}
			}
		}
		if (!KUtil.isEmpty(propConfig)) {
			this.propName = propConfig;
			int ind = propConfig.indexOf('.');//only use name as suffix
			if (ind > 0) {
				propName = propConfig.substring(ind + 1);
			}
			if (!KUtil.isEmpty(propName)) {
				this.chooseFromExcel = KUtil.getPrefVals(session, NewMeopDialogController.PREF_PREFIX_EXCEL + propName);
			}
		}
		initPanel();
		initComponent();
		checkLovRelatedProp(session, prefComponents);
		if(this.fromProcessValue!=null) {
			setValue(this.fromProcessValue);
		}
		return true;
	}

	private void initComponent() throws Exception {
		if (readonly) {
			if (textField != null) {
				textField.setEditable(false);
			}
			if (textArea != null) {
				textArea.setEditable(false);
			}
			if (comboBox != null) {
				comboBox.setEditable(false);
				comboBox.setEnabled(false);
			}
		}
		if (require) {
			if (textField != null) {
				textField.setRequired(true);
			}
			if (textArea != null) {
				textArea.setRequired(true);
			}
			if (comboBox != null) {
				comboBox.setMandatory(true);
			}
		}
	}
	
	private void checkLovRelatedProp(TCSession session, List<PrefComponent> prefComponents) throws Exception {
		if(comboBox==null) {
			return;
		}
		Map<String, Map<String, String>> relateValueMap = new HashMap<String, Map<String,String>>();
		String prefName = NewMeopDialogController.PREF_REL_LOV+propName;
		String[] prefs = KUtil.getPrefVals(session, prefName);
		System.out.println(prefName+ " >> "+Arrays.toString(prefs));
		int prefLen = KUtil.getLen(prefs);
		for(int i=0;i<prefLen;i++) {
			String pref = prefs[i];
			int ind = pref.indexOf(':');
			if(ind<0) {
				continue;
			}
			String realValue = pref.substring(0, ind);
			String[] relateValues = pref.substring(ind+1).split(";");
			int relateLen = KUtil.getLen(relateValues);
			for(int j=0 ;j<relateLen;j++) {
				String relateValue = relateValues[j];
				ind = relateValue.indexOf('=');
				if(ind<=0) {
					continue;
				}
				String relateProp = relateValue.substring(0, ind).trim();
				if(this.propName.equals(relateProp)) {
					continue;
				}
				relateValue = relateValue.substring(ind+1);
				if(KUtil.isEmpty(relateProp)) {
					continue;
				}
				Map<String, String> subMap;
				if(relateValueMap.containsKey(realValue)) {
					subMap = relateValueMap.get(realValue);
				}else {
					subMap = new HashMap<String, String>();
					relateValueMap.put(realValue, subMap);
				}
				subMap.put(relateProp, relateValue);
			}
		}
		if(relateValueMap.size()>0) {
			comboBox.addActionListener(new ActionListener() {
				@Override
				public void actionPerformed(ActionEvent arg0) {
					String item = getValue();
					System.out.println("Select: "+item);
					if(item==null) {
						item = "";
					}
					if(relateValueMap.containsKey(item)) {
						Map<String, String> subMap = relateValueMap.get(item);
						for (PrefComponent comp : prefComponents) {
							if(subMap.containsKey(comp.propName)) {
								comp.setValue(subMap.get(comp.propName));
							}
						}
					}
				}
			});
			
		}
	}

	private void initPanel() {
		// this.panel = new JPanel(new GridBagLayout());
		// this.panel.setPreferredSize(new Dimension(260, 40));
		// GridBagConstraints s = new GridBagConstraints(0, 0, 1, 1, 0, 0,
		// GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 5, 0, 0),
		// 0, 0);
		this.label = new JLabel(title, JLabel.RIGHT);
		// KUtil.newRow(panel, label, s, 1);
		int len = KUtil.getLen(displayLov);
		if (len > 0) {
			comboBox = new iComboBox();
			for (int i = 0; i < len; i++) {
				comboBox.addItem(displayLov[i]);
			}
			// KUtil.addCol(panel, comboBox, s, 1, 1);
		} else {
			if(isTextArea) {
				textArea = new iTextArea(6, 12);
				textArea.setLineWrap(true);
			}else {
				textField = new iTextField(12);
			}
			// KUtil.addCol(panel, textField, s, 1, 1);
		}
	}

	// public Component getPanel() {
	// return panel;
	// }

	public JComponent getValueComp() {
		return textField == null ? (textArea==null?comboBox:textArea) : textField;
	}
	
	public JLabel getLabel() {
		return this.label;
	}

	public void setValue(String value) {
		if (textField != null) {
			textField.setText(value);
		}else if(textArea!=null) {
			textArea.setText(value);
		} else if (comboBox != null) {
			if (value == null) {
				comboBox.setSelectedItem(null);
			} else {
				int ind = KUtil.inArray(value, lov);
				if (ind < 0) {
					ind = KUtil.inArray(value, displayLov);
				}
				if (ind < 0) {
					comboBox.setSelectedItem(null);
				} else {
					comboBox.setSelectedIndex(ind);
				}
			}
		}
	}
	
	public void setValueAndSave(String value) {
		this.savedValue = value;
		if (textField != null) {
			textField.setText(value);
		}else if(textArea!=null) {
			textArea.setText(value);
		} else if (comboBox != null) {
			if (value == null) {
				this.savedValue="";
				comboBox.setSelectedItem(null);
			} else {
				int ind = KUtil.inArray(value, lov);
				if (ind < 0) {
					ind = KUtil.inArray(value, displayLov);
				}
				if (ind < 0) {
					this.savedValue="";
					comboBox.setSelectedItem(null);
				} else {
					this.savedValue = lov[ind];
					comboBox.setSelectedIndex(ind);
				}
			}
		}
	}
	
	public boolean isModified() {
		String val = getValue();
		if(val==null) {
			val = "";
		}
		if(savedValue==null) {
			return !"".equals(val);
		}else {
			return !savedValue.equals(val);
		}
	}
	
	public String getValue() {
		String value = null;
		if (textField != null) {
			value = textField.getText();
		} else if (textArea != null) {
			value = textArea.getText();
		} else if (comboBox != null) {
			int ind = comboBox.getSelectedIndex();
			if (ind >= 0 && ind < KUtil.getLen(lov)) {
				value = lov[ind];
			}
		}
		return value;
	}

	public String getAddtionalValue() {
		String value = null;
		if (textField != null) {
			value = textField.getText();
		} else if(textArea != null) {
			value = textArea.getText();
		} else if (comboBox != null) {
			int ind = comboBox.getSelectedIndex();
			if (ind >= 0 && ind < KUtil.getLen(lov)) {
				value = additional[ind];
			}
		}
		return value;
	}

	public boolean checkRequire() {
		if (!require) {
			return true;
		}
		String val = getValue();
		return val != null && !"".equals(val);
	}

	public void performChoose(AbstractAIFDialog dialog, String type, AbstractAIFApplication app, List<PrefComponent> prefComponents) {
		ChooseDialog chooseDialog = new ChooseDialog(dialog, new ChooseDialogController(app, type, this, prefComponents));
		if (!chooseDialog.initDialog()) {
			chooseDialog = null;
		}
		chooseDialog.showDialog();
//		ChooseDialog chooseDialog = null;
//		if (chooseDialogMap.containsKey(type)) {
//			chooseDialog = chooseDialogMap.get(type);
//			chooseDialog.showDialog();
//			return;
//		}
//		if (chooseDialog == null) {
//			chooseDialog = new ChooseDialog(dialog, new ChooseDialogController(app, type, this, prefComponents));
//			if (!chooseDialog.initDialog()) {
//				chooseDialog = null;
//			}
//		}
//		if (chooseDialog != null) {
//			chooseDialog.showDialog();
//			chooseDialogMap.put(type, chooseDialog);
//		}
	}

	/**
	 * 记录额外的控件，用于控制显示/隐藏
	 * @param comp
	 */
	public void addAdditionalComp(JComponent comp) {
		this.additionalComps.add(comp);
	}
	
	/**
	 * 设置所有相关控件的显示/隐藏
	 * @param visible
	 */
	public void setVisible(boolean visible) {
		label.setVisible(visible);
		getValueComp().setVisible(visible);
		for (JComponent c : additionalComps) {
			c.setVisible(visible);
		}
	}
	
	public boolean hasDefault() {
		System.out.println(getTitle()+"	Default:"+fromProcessValue);
		if(fromProcessValue==null || fromProcessValue.isEmpty())
			return false;
		return true;
	}
	
	public boolean isScyyj() {
		return isScyyj;
	}
}
