package cn.net.connor.process.processcard;

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSeparator;

import com.teamcenter.rac.util.MessageBox;

import cn.net.connor.process.ProcessLocale;
import k.KDialog;
import k.KDialogController;
import k.util.KUtil;

@SuppressWarnings("serial")
public class ProcessCardDialog extends KDialog{

	private JButton b_ok;
	private JButton b_cancel;
	private JCheckBox cb_procname;
	private ProcessCardDialogController controller;
	protected JCheckBox cb_lbjlb;

	public ProcessCardDialog(KDialogController controller) {
		super(controller);
		this.controller = (ProcessCardDialogController)controller;
	}

	@Override
	protected void addListeners() {
		this.b_ok.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				try {
					controller.doExport();
				} catch (Exception e1) {
					e1.printStackTrace();
					MessageBox.post(ProcessCardDialog.this, e1);
				}
			}
		});
		this.b_cancel.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				disposeDialog();
			}
		});
		this.cb_procname.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				cb_lbjlb.setSelected(cb_procname.isSelected());
			}
		});
	}

	@Override
	protected void initUI() {
		this.setTitle(ProcessLocale.getString("processcard.TITLE"));
		this.setLayout(new BorderLayout());
		this.add(BorderLayout.CENTER, initCenterPanel());
		this.add(BorderLayout.SOUTH, initBtnPanel());
		this.setMinimumSize(new Dimension(350,300));
		
	}

	private Component initBtnPanel() {
		JPanel panel = new JPanel(new FlowLayout(FlowLayout.CENTER, 30, 5));
		panel.add(this.b_ok = new JButton(ProcessLocale.getString("ok")));
		panel.add(this.b_cancel = new JButton(ProcessLocale.getString("cancel")));
		return panel;
	}

	private Component initCenterPanel() {
		JPanel panel = new JPanel(new GridBagLayout());
		panel.setBorder(BorderFactory.createEmptyBorder(15,15,20,20));
		GridBagConstraints s = getGridBagConstraints(1, 0, new Insets(5, 5, 0, 0));
		this.cb_procname = new JCheckBox(ProcessLocale.getString("proccardname"));
		KUtil.newRow(panel, new JLabel(ProcessLocale.getString("proccardname")), s, 1);
		KUtil.newRow(panel, new JSeparator(), s, 2);
		KUtil.newRow(panel, this.cb_lbjlb = new JCheckBox(controller.operation.templateName_LBJLB, false), s, 1);
		if(KUtil.isEmpty(controller.operation.templateName_LBJLB)) {
			this.cb_lbjlb.setEnabled(false);
			this.cb_procname.setEnabled(false);
		}
		KUtil.addCol(panel, new JLabel(""), s, 1, 1);
		s.weighty = 1;
		KUtil.newRow(panel, new JLabel(""), s, 1);
		return panel;
	}

}
