package cn.net.connor.process.processcard;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.List;

import javax.swing.JOptionPane;

import com.teamcenter.rac.aif.AbstractAIFApplication;
import com.teamcenter.rac.aif.kernel.AIFComponentContext;
import com.teamcenter.rac.aif.kernel.InterfaceAIFComponent;
import com.teamcenter.rac.kernel.TCComponent;
import com.teamcenter.rac.kernel.TCComponentBOMLine;
import com.teamcenter.rac.kernel.TCComponentItemRevision;

import cn.net.connor.process.ProcessLocale;
import cn.net.connor.process.ProcessUtil;
import k.KOperation;
import k.util.KUtil;
import k.word.KWord;
import k.word.KWordUtil;

public class ProcessCardOperation extends KOperation {

	private TCComponentBOMLine targetLine;
	protected String templateName_LBJLB;
	public static final String PREF_PREFIX_SUMMARY = "Connor_AVIC_GYKPSC_CATE_";
	public static final String PREF_FLAG_GD = "GD#";
	public static final String PREF_FLAG_KEYMEOP = "KEY#";
	// public static final String PREF_PREFIX_PARTLIST =
	// "Connor_AVIC_GYKPSC_LBJLB_";
	// public static final String PREF_PREFIX_PROCCARD = "Connor_AVIC_GYKPSC_GYKP_";
	// public static final String PREF_PREFIX_KEYMEOP = "Connor_AVIC_GYKPSC_GJGX_";
	// public static final String PREF_PREFIX_IMAGE = "Connor_AVIC_GYKPSC_GYFT_";
	// public static final String PREF_PREFIX_IMAGE_GD = "Connor_AVIC_GYKPSC_GDFT_";
	public static final String PREF_GDTYPE = "Connor_AVIC_GDItem_Types";
	private boolean initFlag = false;
	private boolean exportLBJLB = false;
	private KWord lbjlb;
	private List<KWord> kWords = new ArrayList<KWord>();
	private List<String> gdWordsPref = new ArrayList<String>();
	private TCComponentBOMLine processLine;
	private TCComponentItemRevision meTargetRev;
	private String[] gdTypes;
	private String prefPrefix;
	private boolean isGeneralExport;
	private String dsNameFormat;

	public ProcessCardOperation(AbstractAIFApplication app, String opName, String prefName) {
		super(app, opName);
		this.isGeneralExport = !KUtil.isEmpty(prefName);
		this.prefPrefix = KUtil.isEmpty(prefName)?PREF_PREFIX_SUMMARY:prefName;
	}

	public void setExportLBJLB(boolean flag) {
		this.exportLBJLB = flag;
	}

	@Override
	public boolean init() throws Exception {
		if (initFlag) {
			return true;
		}
		InterfaceAIFComponent target = app.getTargetComponent();
		if (target == null || !(target instanceof TCComponentBOMLine)) {
			KUtil.info(null, ProcessLocale.getString("selectmeop.INFO"));
			return false;
		}
		this.targetLine = (TCComponentBOMLine) target;
		System.out.println("Target line: " + this.targetLine);
		TCComponentItemRevision targetRev = this.targetLine.getItemRevision();
		if (!ProcessUtil.isMEOP(targetRev.getItem().getType())) {
			// if (!(targetRev instanceof TCComponentMEOPRevision)) {
			KUtil.info(null, ProcessLocale.getString("selectmeop.INFO"));
			return false;
		}
		// find process
		TCComponentBOMLine pLine = this.targetLine.parent();
		while (pLine != null) {
			if (ProcessUtil.isMEProcess(pLine.getItem().getType())) {
				// if (pLine.getItemRevision() instanceof TCComponentMEProcessRevision) {
				this.processLine = pLine;
				break;
			}
			pLine = pLine.parent();
		}
		System.out.println("Process line: " + this.processLine);
		if (this.processLine != null) {
			this.meTargetRev = (TCComponentItemRevision) this.processLine.getItemRevision().getRelatedComponent("IMAN_METarget");
			System.out.println("METarget: " + this.meTargetRev);
		}
		if (this.meTargetRev == null) {
			KUtil.info(null, ProcessLocale.getString("metargetnotfound.ERROR"));
			return false;
		}
		String prefSuffix = meTargetRev.getType();
		String isKeyMeop = targetRev.getRelatedComponent("IMAN_master_form_rev").getStringProperty("ac5_KeyProcessOrNot");
		System.out.println("Is key meop: " + isKeyMeop);
		// category
		{
			String prefName = prefPrefix + targetRev.getType();
			System.out.println("Read Category Pref: " + prefName);
			String[] cates = KUtil.getPrefVals(session, prefName);
			int len = KUtil.getLen(cates);
			if (len < 1) {
				KUtil.info(null, String.format(ProcessLocale.getString("preferror.ERROR1"), prefName));
				return false;
			}
			if(isGeneralExport) {
				this.dsNameFormat = cates[0];
			}else {
				try {
					this.lbjlb = new KWord(session, cates[0] + prefSuffix);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			for (int i = 1; i < len; i++) {
				String catePref = cates[i] + prefSuffix;
				if (catePref.startsWith(PREF_FLAG_GD)) {
					this.gdWordsPref.add(catePref.substring(PREF_FLAG_GD.length()));
				} else if (catePref.startsWith(PREF_FLAG_KEYMEOP)) {
					if ("true".equals(isKeyMeop)) {
						this.kWords.add(new KWord(session, catePref.substring(PREF_FLAG_KEYMEOP.length())));
					}
				} else {
					this.kWords.add(new KWord(session, catePref));
				}
			}
			if (this.lbjlb != null) {
				System.out.println(">> LBJLB Dataset: " + this.lbjlb.getTemplateDataset());
				this.templateName_LBJLB = this.lbjlb.getTemplateDataset().getProperty("object_name");
			}
			// gd item types
			this.gdTypes = KUtil.getPrefVals(session, PREF_GDTYPE);
			System.out.println("GD Item Types: " + Arrays.toString(this.gdTypes));
		}
		// this.kWords.add(new KWord(session, ProcessCardOperation.PREF_PREFIX_PROCCARD
		// + prefSuffix));
		// if("true".equals(isKeyMeop)) {
		// this.kWords.add(new KWord(session,
		// ProcessCardOperation.PREF_PREFIX_KEYMEOP+prefSuffix));
		// }
		// this.kWords.add(new KWord(session,
		// ProcessCardOperation.PREF_PREFIX_IMAGE+prefSuffix));
		// System.out.println(">> LBJLB Dataset: " + this.lbjlb.getTemplateDataset());
		// this.templateName_LBJLB =
		// this.lbjlb.getTemplateDataset().getProperty("object_name");
		// // gd item types
		// this.gdTypes = KUtil.getPrefVals(session, PREF_GDTYPE);
		// System.out.println("GD Item Types: " + Arrays.toString(this.gdTypes));
		// // gdft
		// gdWords.add(new KWord(session, PREF_PREFIX_IMAGE_GD+prefSuffix));
		{
			TCComponentItemRevision gxRev = targetLine.getItemRevision();
			System.out.println("MEOP Rev: " + gxRev);
			TCComponent gxForm = gxRev.getRelatedComponent("IMAN_master_form_rev");
			String profession = gxForm.getStringProperty("ac5_Profession");
			String opNumber = gxForm.getStringProperty("ac5_OperationNumber");
			String name = gxRev.getStringProperty("object_name");
			System.out.println("profession = " + profession);
			System.out.println("operation number = " + opNumber);
			System.out.println("name = " + name);
			if (profession == null) {
				profession = "";
			}
			if (opNumber == null) {
				opNumber = "";
			}
			String checkExit = opNumber + name;
			if (!KUtil.isEmpty(checkExit)) {
				if (hasDataset(gxRev, "MSWordX", checkExit, KWord.REL_REV_DOC)) {
					int op = JOptionPane.showOptionDialog(getCurrentDesktop(), ProcessLocale.getString("processcardexist.OPTION"), "", JOptionPane.YES_NO_OPTION, JOptionPane.INFORMATION_MESSAGE, null, null,
							JOptionPane.YES_OPTION);
					if (op != JOptionPane.YES_OPTION) {
						System.out.println("Cancel Export");
						return false;
					}
				}
			}
		}
		initFlag = true;
		return true;
	}

	public static boolean hasDataset(TCComponent rev, String dsType, String dsName, String rel) throws Exception {
		if (rev == null || KUtil.isEmpty(dsName)) {
			return false;
		}
		System.out.println("Check Dataset: " + rev + " -> " + dsName + "|" + dsType + "|" + rel);
		rev.refresh();
		TCComponent[] kids = rev.getRelatedComponents(rel);
		System.out.println("Child: " + Arrays.toString(kids));
		for (TCComponent c : kids) {
			if (c.getType().equals(dsType) && c.toString().contains(dsName)) {
				System.out.println("Find Exist: " + c);
				return true;
			}
		}
		return false;
	}

	@Override
	public void execute() throws Exception {
		System.out.println("Start Export Process Card...");
		System.out.println("Export LBJLB: " + this.exportLBJLB);
		// this.kWords.clear(); // TODO
		// this.gdWords.clear();// TODO test lbjlb
		if (this.exportLBJLB && this.lbjlb != null) {
			this.kWords.add(0, this.lbjlb);
		}
		String dsName = formatName();
		List<KWord> combinelist = new ArrayList<KWord>();
		List<TCComponentBOMLine> targetLines = new ArrayList<TCComponentBOMLine>();
		List<TCComponentItemRevision> meTargetRevs = new ArrayList<TCComponentItemRevision>();
		List<String[]> item2TypesList = new ArrayList<String[]>();
		int size = this.kWords.size();
		for (int i = 0; i < size; i++) {
			combinelist.add(kWords.get(i));
			targetLines.add(targetLine);
			meTargetRevs.add(meTargetRev);
			item2TypesList.add(gdTypes);
		}
		size = gdWordsPref.size();
		if (size > 0) {
			// export gd images
			AIFComponentContext[] cc = targetLine.getChildren();
			int cnt = KUtil.getLen(cc);
			for (int i = 0; i < cnt; i++) {
				TCComponentBOMLine cLine = (TCComponentBOMLine) cc[i].getComponent();
				String cItemType = cLine.getStringProperty("bl_item_object_type");
				// System.out.println(cLine+" >> "+cItemType);
				if (KUtil.inArray(cItemType, gdTypes) >= 0) { // reorder child line by different types.
					System.out.println(String.format("Export GD Line: [%s](%s)", i + 1, cLine.toString(), cItemType));
					for (int j = 0; j < size; j++) {
						combinelist.add(new KWord(session, gdWordsPref.get(j)));
						targetLines.add(cLine);
						meTargetRevs.add(meTargetRev);
						item2TypesList.add(gdTypes);
					}
				}
			}
		}

		KWordUtil.startWord();
		try {
			KWord.export2(session, combinelist, dsName, targetLine, targetLines, meTargetRevs,!isGeneralExport);
		} finally {
			KWordUtil.closeWord();
		}
		session.refreshComponentsByType("CfgBlAttachmentLine");
		session.refreshComponentsByType("MSWordX");
		System.out.println("Export Process Card Complete");
		KUtil.info(null, ProcessLocale.getString("proccardsuccess.INFO"));
	}
	
	private String formatName() throws Exception {
		String dsName;
		if(KUtil.isEmpty(dsNameFormat)) {
			dsName = ProcessLocale.getString("proccard.FILENAME");// + KUtil.getDateStr(new Date(), "yyyyMMdd");
			// String ftName = ProcessLocale.getString("procimage.FILENAME") + "_" +
			// KUtil.getDateStr(new Date(), "yyyyMMdd");
			{
				TCComponentItemRevision gxRev = targetLine.getItemRevision();
				System.out.println("MEOP Rev: " + gxRev);
				TCComponent gxForm = gxRev.getRelatedComponent("IMAN_master_form_rev");
				String profession = gxForm.getStringProperty("ac5_Profession");
				String opNumber = gxForm.getStringProperty("ac5_OperationNumber");
				String name = gxRev.getStringProperty("object_name");
				System.out.println("profession = " + profession);
				System.out.println("operation number = " + opNumber);
				System.out.println("name = " + name);
				if (profession == null) {
					profession = "";
				}
				if (opNumber == null) {
					opNumber = "";
				}
				dsName = profession + opNumber + name + dsName;
				List<TCComponent> datasets = KUtil.getChildComponents(gxRev, "MSWordX", KWord.REL_REV_DOC, dsName);
				System.out.println(">> find datasets: " + datasets);
				TCComponent latestDataset = KUtil.getLatestComponent(datasets);
				System.out.println(">> latest: " + latestDataset);
				if (latestDataset != null) {
					dsName = latestDataset.getStringProperty("object_name");
				} else {
					dsName = dsName + KUtil.getDateStr(new Date(), "yyyyMMdd");
				}
			}
		}else {
			dsName = dsNameFormat;
			int ind = dsName.lastIndexOf(':');
			String time = "";
			if (ind > 0) {
				time = new SimpleDateFormat(dsName.substring(ind + 1)).format(new Date());
				dsName = dsName.substring(0, ind);
			}
			TCComponentItemRevision rev = this.targetLine.getItemRevision();
			String value = KUtil.getConfigPropValue(rev, dsName);
			dsName = value + time;
		}
		System.out.println("Dataset Name: " + dsName);
		return dsName;
	}

	public void execute_backup20200813() throws Exception {
		System.out.println("Start Export Process Card...");
		System.out.println("Export LBJLB: " + this.exportLBJLB);
		if (this.exportLBJLB) {
			this.kWords.add(0, this.lbjlb);
		}
		String dsName = ProcessLocale.getString("proccard.FILENAME") + "_" + KUtil.getDateStr(new Date(), "yyyyMMdd");
		// String ftName = ProcessLocale.getString("procimage.FILENAME") + "_" +
		// KUtil.getDateStr(new Date(), "yyyyMMdd");
		KWordUtil.startWord();
		try {
			KWord.export(session, kWords, dsName, targetLine, meTargetRev, gdTypes);
			// if(gdWords.size()>0) {
			// // export gd images
			// AIFComponentContext[] cc = targetLine.getChildren();
			// int cnt = KUtil.getLen(cc);
			// for (int i = 0; i < cnt; i++) {
			// TCComponentBOMLine cLine = (TCComponentBOMLine) cc[i].getComponent();
			// String cItemType = cLine.getStringProperty("bl_item_object_type");
			// if (KUtil.inArray(cItemType, gdTypes) >= 0) { // reorder child line by
			// different types.
			// System.out.println(String.format("Export GD Line: [%s](%s)", i + 1,
			// cLine.toString(), cItemType));
			// KWord.export(session, gdWords, ftName, cLine, meTargetRev, gdTypes);
			// }
			// }
			// }
		} finally {
			KWordUtil.closeWord();
		}
		System.out.println("Export Process Card Complete");
		KUtil.info(null, ProcessLocale.getString("proccardsuccess.INFO"));
	}

}
