package cn.net.connor.process.processcardmultiple;

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.List;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableColumnModel;

import com.teamcenter.rac.util.MessageBox;

import cn.net.connor.process.ProcessLocale;
import k.KDialog;
import k.KDialogController;

@SuppressWarnings("serial")
public class MultiProcessCardDialog extends KDialog{

	private MultiProcessCardDialogController controller;
	private JButton b_ok;
	private JButton b_cancel;
	private DefaultTableModel tableModel;
	protected JTable table;

	public MultiProcessCardDialog(KDialogController controller) {
		super(controller);
		this.controller = (MultiProcessCardDialogController)controller;
	}

	@Override
	protected void addListeners() {
		this.b_ok.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				try {
					controller.doExport();
				} catch (Exception e1) {
					e1.printStackTrace();
					MessageBox.post(MultiProcessCardDialog.this, e1);
				}
			}
		});
		this.b_cancel.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				disposeDialog();
			}
		});
	}

	@Override
	protected void initUI() {
		this.setTitle(ProcessLocale.getString("processcard.TITLE"));
		this.setLayout(new BorderLayout());
		this.add(BorderLayout.CENTER, initCenterPanel());
		this.add(BorderLayout.SOUTH, initBtnPanel());
	}

	private Component initBtnPanel() {
		JPanel panel = new JPanel(new FlowLayout(FlowLayout.CENTER, 30, 5));
		panel.add(this.b_ok = new JButton(ProcessLocale.getString("ok")));
		panel.add(this.b_cancel = new JButton(ProcessLocale.getString("cancel")));
		return panel;
	}

	private Component initCenterPanel() {
		JPanel panel = new JPanel(new BorderLayout());
		panel.setBorder(BorderFactory.createEmptyBorder(5, 5, 0, 5));
		this.tableModel = new DefaultTableModel();
		this.table = new JTable(tableModel) {
			@Override
			public boolean isCellEditable(int row, int column) {
				return column==0;
			}
			public Class<?> getColumnClass(int column) {
				if (column == 0) {
					return Boolean.class;
				}
				return super.getColumnClass(column);
			}
		};
		table.getTableHeader().setReorderingAllowed(false);
		table.getTableHeader().setDefaultRenderer(new CheckBoxTableHeaderRenderer(table, 0, false));
		table.setRowHeight(23);
		String[] header = new String[] {"", ProcessLocale.getString("index.COLNAME"), ProcessLocale.getString("opno.COLNAME"), ProcessLocale.getString("wordpage.COLNAME")};
		tableModel.setDataVector(null, header);
		List<MultiProcessCardBean> data = controller.operation.exportBeans;
		int rowCnt = data.size();
		for(int i=0; i<rowCnt; i++) {
			MultiProcessCardBean bean = data.get(i);
			tableModel.addRow(bean.getRowData(i+1));
		}
		TableColumnModel colModel = table.getColumnModel();
		colModel.getColumn(0).setPreferredWidth(50);
		colModel.getColumn(1).setPreferredWidth(60);
		colModel.getColumn(2).setPreferredWidth(70);
		colModel.getColumn(3).setPreferredWidth(200);
		JScrollPane scroll = new JScrollPane(table);
		panel.add(BorderLayout.CENTER, scroll);
		scroll.setPreferredSize(new Dimension(400, 250));
		return panel;
	}

}
