package cn.net.connor.process.processprocedure;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.List;

import javax.swing.JOptionPane;

import com.teamcenter.rac.aif.AbstractAIFApplication;
import com.teamcenter.rac.aif.kernel.InterfaceAIFComponent;
import com.teamcenter.rac.kernel.TCComponent;
import com.teamcenter.rac.kernel.TCComponentBOMLine;
import com.teamcenter.rac.kernel.TCComponentItemRevision;

import cn.net.connor.process.ProcessLocale;
import cn.net.connor.process.ProcessUtil;
import cn.net.connor.process.processcard.ProcessCardOperation;
import k.KOperation;
import k.util.KUtil;
import k.word.KWord;
import k.word.KWordUtil;

public class ProcessProcOperation extends KOperation {

	private TCComponentBOMLine targetLine;
	protected String templateName_LBJLB;
	public static final String PREF_PREFIX_SUMMARY = "Connor_AVIC_GYGCSC_CATE_";
//	public static final String PREF_PREFIX_GYGC = "Connor_AVIC_GYKPSC_GYGC_";
//	public static final String PREF_PREFIX_GYQS = "Connor_AVIC_GYKPSC_GYQSKP_";
//	public static final String PREF_PREFIX_FLQD = "Connor_AVIC_GYKPSC_FLQD_";
//	public static final String PREF_PREFIX_GYCX = "Connor_AVIC_GYKPSC_GYCXKP_";
	private boolean initFlag = false;
	private boolean exportLBJLB = false;
	private KWord flqd;
	private List<KWord> kWords = new ArrayList<KWord>();
	private TCComponentItemRevision meTargetRev;
	private KWord gyqs;

	public ProcessProcOperation(AbstractAIFApplication app, String opName) {
		super(app, opName);
	}

	public void setExportLBJLB(boolean flag) {
		this.exportLBJLB = flag;
	}

	@Override
	public boolean init() throws Exception {
		if (initFlag) {
			return true;
		}
		InterfaceAIFComponent target = app.getTargetComponent();
		if (target == null || !(target instanceof TCComponentBOMLine)) {
			KUtil.info(null,ProcessLocale.getString("selectmeprocess.INFO"));
			return false;
		}
		this.targetLine = (TCComponentBOMLine) target;
		System.out.println("Target line: " + this.targetLine);
		TCComponentItemRevision targetRev = this.targetLine.getItemRevision();
		if (!ProcessUtil.isMEProcess(targetRev.getItem().getType())) {
			//if (!(targetRev instanceof TCComponentMEProcessRevision)) {
			KUtil.info(null,ProcessLocale.getString("selectmeprocess.INFO"));
			return false;
		}
		if (this.targetLine != null) {
			this.meTargetRev = (TCComponentItemRevision) this.targetLine.getItemRevision().getRelatedComponent("IMAN_METarget");
			System.out.println("METarget: " + this.meTargetRev);
		}
		if(this.meTargetRev==null) {
			KUtil.info(null, ProcessLocale.getString("metargetnotfound.ERROR"));
			return false;
		}
		String prefSuffix = meTargetRev.getType();
		{
			String prefName = PREF_PREFIX_SUMMARY + targetRev.getType();
			System.out.println("Read Category Pref: "+prefName);
			String[] cates = KUtil.getPrefVals(session, prefName);
			int len = KUtil.getLen(cates);
			if(len<2) {
				KUtil.info(null, String.format(ProcessLocale.getString("preferror.ERROR1"), prefName));
				return false;
			}
			try {
				this.flqd = new KWord(session, cates[0]+prefSuffix);
			} catch (Exception e) {
				e.printStackTrace();
			}
			try {
				this.gyqs = new KWord(session, cates[1]+prefSuffix);
			} catch (Exception e) {
				e.printStackTrace();
			}
			for(int i=2;i<len;i++) {
				this.kWords.add(new KWord(session, cates[i]+prefSuffix));
			}
		}
		//this.flqd = new KWord(session,  ProcessProcOperation.PREF_PREFIX_FLQD + prefSuffix);
		//this.kWords.add(new KWord(session, ProcessProcOperation.PREF_PREFIX_GYGC + prefSuffix));
		
		//this.gyqs = new KWord(session, ProcessProcOperation.PREF_PREFIX_GYQS+prefSuffix);
		//this.kWords.add(new KWord(session, ProcessProcOperation.PREF_PREFIX_GYCX+prefSuffix));
		if(this.flqd!=null) {
			System.out.println(">> LBJLB Dataset: " + this.flqd.getTemplateDataset());
			this.templateName_LBJLB = this.flqd.getTemplateDataset().getProperty("object_name");
		}
		{
			TCComponentItemRevision gyRev = this.targetLine.getItemRevision();
			System.out.println("MEProcess Rev: "+gyRev);
			String id = gyRev.getStringProperty("item_id");
			String name = gyRev.getStringProperty("object_name");
			System.out.println("id: "+id);
			System.out.println("name: "+name);
			String checkExit = id+name;
			if(!KUtil.isEmpty(checkExit)) {
				if(ProcessCardOperation.hasDataset(gyRev, "MSWordX", checkExit, KWord.REL_REV_DOC)) {
					int op = JOptionPane.showOptionDialog(getCurrentDesktop(), ProcessLocale.getString("processcardexist.OPTION"), "", JOptionPane.YES_NO_OPTION, JOptionPane.INFORMATION_MESSAGE, null, null, JOptionPane.YES_OPTION);
					if(op!=JOptionPane.YES_OPTION) {
						System.out.println("Cancel Export");
						return false;
					}
				}
			}
		}
		initFlag = true;
		return true;
	}
	
	@Override
	public void execute() throws Exception {
		System.out.println("Start Export Process Procedure...");
		System.out.println("Export FLQD: " + this.exportLBJLB);
		if(this.exportLBJLB&&this.flqd!=null) {
			this.kWords.add(1, this.flqd);
		}
		TCComponent[] revs = this.targetLine.getItem().getReferenceListProperty("revision_list");
		System.out.println(">> Revisions: "+Arrays.toString(revs));
		if(KUtil.getLen(revs)>0&&this.gyqs!=null) {// 20200921 change 1 to 0
			this.kWords.add(1, this.gyqs);
		}
		
		List<KWord> combinelist = new ArrayList<KWord>();
		List<TCComponentBOMLine> targetLines = new ArrayList<TCComponentBOMLine>();
		List<TCComponentItemRevision> meTargetRevs = new ArrayList<TCComponentItemRevision>();
		int size= this.kWords.size();
		for(int i=0;i<size;i++) {
			combinelist.add(kWords.get(i));
			targetLines.add(targetLine);
			meTargetRevs.add(meTargetRev);
		}
		String dsName =  ProcessLocale.getString("procprocedure.FILENAME");// + KUtil.getDateStr(new Date(), "yyyyMMdd");
		{
			TCComponentItemRevision gyRev = this.targetLine.getItemRevision();
			System.out.println("MEProcess Rev: "+gyRev);
			String id = gyRev.getStringProperty("item_id");
			String name = gyRev.getStringProperty("object_name");
			System.out.println("id: "+id);
			System.out.println("name: "+name);
			dsName=id+name+dsName;
			
			List<TCComponent> datasets = KUtil.getChildComponents(gyRev, "MSWordX", KWord.REL_REV_DOC, dsName);
			System.out.println(">> find datasets: " + datasets);
			TCComponent latestDataset = KUtil.getLatestComponent(datasets);
			System.out.println(">> latest: " + latestDataset);
			if (latestDataset != null) {
				dsName = latestDataset.getStringProperty("object_name");
			} else {
				dsName = dsName + KUtil.getDateStr(new Date(), "yyyyMMdd");
			}
		}
		KWordUtil.startWord();
		try {
			KWord.export2(session, combinelist, dsName, targetLine, targetLines, meTargetRevs);
			//KWord.export(session, kWords, dsName, targetLine, meTargetRev, null);
		} finally {
			KWordUtil.closeWord();
		}
		session.refreshComponentsByType("CfgBlAttachmentLine");
		session.refreshComponentsByType("MSWordX");
		System.out.println("Export Process Procedure Complete");
		KUtil.info(null,ProcessLocale.getString("procproceduresuccess.INFO"));
	}

}
