package cn.net.connor.process.processprocedure;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.List;

import com.teamcenter.rac.aif.AbstractAIFApplication;
import com.teamcenter.rac.aif.kernel.InterfaceAIFComponent;
import com.teamcenter.rac.kernel.TCComponent;
import com.teamcenter.rac.kernel.TCComponentBOMLine;
import com.teamcenter.rac.kernel.TCComponentItemRevision;

import cn.net.connor.process.ProcessLocale;
import cn.net.connor.process.ProcessUtil;
import k.KOperation;
import k.util.KUtil;
import k.word.KWord;
import k.word.KWordUtil;

public class ProcessProcOperation_backup20200812 extends KOperation {

	private TCComponentBOMLine targetLine;
	protected String templateName_LBJLB;
	public static final String PREF_PREFIX_GYGC = "Connor_AVIC_GYKPSC_GYGC_";
	public static final String PREF_PREFIX_GYQS = "Connor_AVIC_GYKPSC_GYQSKP_";
	public static final String PREF_PREFIX_FLQD = "Connor_AVIC_GYKPSC_FLQD_";
	public static final String PREF_PREFIX_GYCX = "Connor_AVIC_GYKPSC_GYCXKP_";
	private boolean initFlag = false;
	private boolean exportLBJLB = false;
	private KWord flqd;
	private List<KWord> kWords = new ArrayList<KWord>();
	private TCComponentItemRevision meTargetRev;
	private KWord gyqs;

	public ProcessProcOperation_backup20200812(AbstractAIFApplication app, String opName) {
		super(app, opName);
	}

	public void setExportLBJLB(boolean flag) {
		this.exportLBJLB = flag;
	}

	@Override
	public boolean init() throws Exception {
		if (initFlag) {
			return true;
		}
		InterfaceAIFComponent target = app.getTargetComponent();
		if (target == null || !(target instanceof TCComponentBOMLine)) {
			KUtil.info(null,ProcessLocale.getString("selectmeprocess.INFO"));
			return false;
		}
		this.targetLine = (TCComponentBOMLine) target;
		System.out.println("Target line: " + this.targetLine);
		TCComponentItemRevision targetRev = this.targetLine.getItemRevision();
		if (!ProcessUtil.isMEProcess(targetRev.getItem().getType())) {
			//if (!(targetRev instanceof TCComponentMEProcessRevision)) {
			KUtil.info(null,ProcessLocale.getString("selectmeprocess.INFO"));
			return false;
		}
		if (this.targetLine != null) {
			this.meTargetRev = (TCComponentItemRevision) this.targetLine.getItemRevision().getRelatedComponent("IMAN_METarget");
			System.out.println("METarget: " + this.meTargetRev);
		}
		if(this.meTargetRev==null) {
			KUtil.info(null, ProcessLocale.getString("metargetnotfound.ERROR"));
			return false;
		}
		String prefSuffix = meTargetRev.getType();
		this.flqd = new KWord(session,  ProcessProcOperation_backup20200812.PREF_PREFIX_FLQD + prefSuffix);
		this.kWords.add(new KWord(session, ProcessProcOperation_backup20200812.PREF_PREFIX_GYGC + prefSuffix));
		
		this.gyqs = new KWord(session, ProcessProcOperation_backup20200812.PREF_PREFIX_GYQS+prefSuffix);
		this.kWords.add(new KWord(session, ProcessProcOperation_backup20200812.PREF_PREFIX_GYCX+prefSuffix));
		System.out.println(">> LBJLB Dataset: " + this.flqd.getTemplateDataset());
		this.templateName_LBJLB = this.flqd.getTemplateDataset().getProperty("object_name");
		initFlag = true;
		return true;
	}
	
	@Override
	public void execute() throws Exception {
		System.out.println("Start Export Process Procedure...");
		System.out.println("Export FLQD: " + this.exportLBJLB);
		if(this.exportLBJLB) {
			this.kWords.add(1, this.flqd);
		}
		TCComponent[] revs = this.targetLine.getItem().getReferenceListProperty("revision_list");
		System.out.println(">> Revisions: "+Arrays.toString(revs));
		if(KUtil.getLen(revs)>1) {
			this.kWords.add(1, this.gyqs);
		}
		String dsName =  ProcessLocale.getString("procprocedure.FILENAME") + "_" + KUtil.getDateStr(new Date(), "yyyyMMdd");
		KWordUtil.startWord();
		try {
			KWord.export(session, kWords, dsName, targetLine, meTargetRev, null);
		} finally {
			KWordUtil.closeWord();
		}
		System.out.println("Export Process Procedure Complete");
		KUtil.info(null,ProcessLocale.getString("procproceduresuccess.INFO"));
	}

}
