package cn.net.connor.process.processview;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;

import com.teamcenter.rac.aif.kernel.AIFComponentContext;
import com.teamcenter.rac.aifrcp.AIFUtility;
import com.teamcenter.rac.kernel.TCComponent;
import com.teamcenter.rac.kernel.TCComponentBOMLine;
import com.teamcenter.rac.kernel.TCComponentBOMWindow;
import com.teamcenter.rac.kernel.TCComponentBOMWindowType;
import com.teamcenter.rac.kernel.TCComponentContextList;
import com.teamcenter.rac.kernel.TCComponentForm;
import com.teamcenter.rac.kernel.TCComponentItem;
import com.teamcenter.rac.kernel.TCComponentItemRevision;
import com.teamcenter.rac.kernel.TCComponentQuery;
import com.teamcenter.rac.kernel.TCComponentQueryType;
import com.teamcenter.rac.kernel.TCException;
import com.teamcenter.rac.kernel.TCSession;
import com.teamcenter.rac.util.MessageBox;
import com.teamcenter.rac.util.combobox.iComboBox;

import cn.net.connor.process.ProcessLocale;
import cn.net.connor.process.newmeop.PrefComponent;
import k.KLocale;
import k.util.KUtil;
import cn.net.connor.process.hourcalculation.*;

@SuppressWarnings("serial")
public class PropertyPanel extends JPanel{
	
	private TCComponentBOMLine targetLine;
	public static final String PREF_PREFIX = "Connor_AVIC_ME_Properties_";
	private List<PrefComponent> prefComponents = new ArrayList<PrefComponent>();
	public static final String FLAG_HIDE_LISTENTER = "HIDE_LISTENER:";
	
	public JTextField Field1=new JTextField();
	public JTextField Field2=new JTextField();
	public JTextField Field3=new JTextField();
	public JTextField Field4=new JTextField();
	public JTextField Field5=new JTextField();
	
	public boolean refreshUI(TCComponentBOMLine targetLine) throws Exception{
		System.out.println("Reload: "+targetLine);
		if (targetLine!=null&&targetLine.equals(this.targetLine)) {
			System.out.println("SKIP LOAD");
			return true;
		}
		if(isModified()) {
			int op = JOptionPane.showConfirmDialog(this, ProcessLocale.getString("savedata.INFO"), ProcessLocale.getString("info"), 
					JOptionPane.YES_NO_CANCEL_OPTION);
			if(op==JOptionPane.YES_OPTION) {//save
				try {
					save();
				} catch (Exception e) {
					e.printStackTrace();
					MessageBox.post(e);
					return true;
				}
			}else if(op==JOptionPane.NO_OPTION) {//change
				
			}else {//do nothing
				return true;
			}
		}
		this.removeAll();
		this.setLayout(new GridBagLayout());
		this.setBorder(BorderFactory.createEmptyBorder(20,20,20,20));
		GridBagConstraints s = new GridBagConstraints(0, 0, 1, 1, 0, 0, GridBagConstraints.CENTER, GridBagConstraints.BOTH, 
				new Insets(6, 5, 6, 5), 0, 0);
		if (targetLine == null) {
			this.targetLine = null;
			KUtil.newRow(this, new JLabel(ProcessLocale.getString("processviewnoselect.INFO")), s, 1);
			return false;
		}
		this.targetLine = targetLine;
		TCComponentItem targetItem = targetLine.getItem();
		String itemType = targetItem.getType();
		System.out.println("Type: " + itemType);
		String prefName = PREF_PREFIX+ itemType;
		String[] prefs = KUtil.getPrefVals(KUtil.session, prefName);
		this.prefComponents.clear();
		int len = KUtil.getLen(prefs);
		Map<String[],String[]> hideListenerMap = new HashMap<String[], String[]>(); 
		System.out.println("Load Pref: "+prefName);
		for(int i=0;i<len;i++) {
			String pref = prefs[i];
			if(pref.startsWith(FLAG_HIDE_LISTENTER)) {
				String cond = pref.substring(FLAG_HIDE_LISTENTER.length());
				System.out.println("Hide Listener: "+cond);
				int ind = cond.indexOf(':');
				if(ind>0) {
					String[] hidePropNames = cond.substring(ind+1).split(";");
					cond = cond.substring(0, ind);
					ind = cond.indexOf('=');
					if(ind>0) {
						String condPropName = cond.substring(0, ind);
						String condPropValue = cond.substring(ind+1);
						if(!KUtil.isEmpty(condPropName)&&KUtil.getLen(hidePropNames)>0) {
							hideListenerMap.put(new String[] {condPropName, condPropValue}, hidePropNames);
						}
					}
				}
				continue;
			}
			PrefComponent comp = new PrefComponent(pref);
			if(comp.init(KUtil.session)) {
				if(comp.canDisplay(targetLine.getItemRevision())) {
					this.prefComponents.add(comp);
				}else {
					System.out.println("HIDE Config: "+pref);
				}
			}else {
				System.out.println("ERROR Config: "+pref);
			}
		}
		if(this.prefComponents.size()==0) {
			System.out.println("No Valid Pref: " + prefName);
			KUtil.newRow(this, new JLabel(String.format(ProcessLocale.getString("prefnotconfiged.ERROR1"), prefName)), s, 1);
			return false;
		}
		Map<PrefComponent,JButton> chooseComponents = new HashMap<PrefComponent, JButton>();
		
		for (PrefComponent prefComponent : prefComponents) {
			KUtil.newRow(this, prefComponent.getLabel(), s, 1);
			JComponent valueComp = prefComponent.getValueComp();
			if(valueComp instanceof JTextArea) {
				JScrollPane scroll = new JScrollPane(valueComp);
				prefComponent.addAdditionalComp(scroll);
				KUtil.addCol(this, scroll, s, 1, 1);
 			}else {
 				//+++
 				if(prefComponent.getPropConfig().equals("revmaster.ac5_SingleWorkingHours")) {//ʱ
 					Field1=(JTextField) valueComp;
 				}
 				if(prefComponent.getPropConfig().equals("revmaster.ac5_AccurateHours")) {//׼Ṥʱ
 					Field2=(JTextField) valueComp;
 				}
 				if(prefComponent.getPropConfig().equals("revmaster.ac5_Other")) {//
 					Field3=(JTextField) valueComp;
 				}
 				if(prefComponent.getPropConfig().equals("revmaster.ac5_Remark")) {//ע
 					Field4=(JTextField) valueComp;
 				}
 				if(prefComponent.getPropConfig().equals("revmaster.ac5_ItemNumber")) {//
 					Field5=(JTextField) valueComp;
 				}
 				//+++
 				KUtil.addCol(this, valueComp, s, 1, 1);
 			}
			
			
			//TODO +++Ӱť
			if(KUtil.getLen(prefComponent.getExcelConfig())>0) {
				
				JButton b_choose = new JButton(ProcessLocale.getString("select"));
				KUtil.addCol(this, b_choose, s, 1, 0);
				chooseComponents.put(prefComponent, b_choose);
				prefComponent.addAdditionalComp(b_choose);
			}
			if(prefComponent.isScyyj()) {
				JButton b_choose = new JButton(ProcessLocale.getString("search"));
				b_choose.addActionListener(new ActionListener() {
					@Override
					public void actionPerformed(ActionEvent e) {
						try {
							TCComponentItemRevision prev = targetLine.getItemRevision();
							StringBuilder scyy = new StringBuilder("");
							TCComponent[] mets = prev.getReferenceListProperty("IMAN_METarget");
							TCSession session = prev.getSession();
							for(TCComponent met : mets) {
								TCComponentBOMWindow window = getWindow(session);
								TCComponentBOMLine bom = window.setWindowTopLine(null, (TCComponentItemRevision) met, null, null);
								AIFComponentContext[] child = bom.getChildren();
								window.save();
								String ac5_ProductModel = met.getChildren("IMAN_master_form_rev")[0].getComponent().getProperty("ac5_ProductModel");
								if(child.length>0) {
									for(AIFComponentContext c : child) {
										TCComponentBOMLine line = (TCComponentBOMLine) c.getComponent();
										TCComponentItemRevision rev = line.getItemRevision();
										TCComponentForm form = (TCComponentForm) rev.getChildren("IMAN_master_form_rev")[0].getComponent();
										if(form.getProperty("ac5_Scyyxh").equals(ac5_ProductModel)) {
											scyy.append("").append(rev.getProperty("item_id")).append("").append(rev.getProperty("object_name"));
										}
									}
								}else {
									String ac5_MaterialCode = met.getChildren("IMAN_master_form_rev")[0].getComponent().getProperty("ac5_MaterialCode");
									TCComponent[] results = query(session, "Search_SCYY", new String[] { "ϱ", "Ʒͺ" }, new String[] { ac5_MaterialCode, ac5_ProductModel });
									for(TCComponent c : results) {
										scyy.append("").append(c.getProperty("item_id")).append("").append(c.getProperty("object_name"));
									}
								}
								window.close();
							}
							if(scyy.length()>0) {
								prefComponent.setValue(scyy.substring(1));
							}else {
								prefComponent.setValue("");
							}
						} catch (Exception e1) {
							e1.printStackTrace();
							MessageBox.post(AIFUtility.getActiveDesktop(), ""+e1.getMessage(), "ERROR", MessageBox.ERROR);
						}
					}
				});
				KUtil.addCol(this, b_choose, s, 1, 0);
//				chooseComponents.put(prefComponent, b_choose);
				prefComponent.addAdditionalComp(b_choose);
			}
			//Ӽ㰴ť:ʱ=revmaster.ac5_SingleWorkingHours;ڵʱӼ㰴ť
			if(prefComponent.getPropConfig().equals("revmaster.ac5_SingleWorkingHours")) {
				JButton b_choose = new JButton("");
				KUtil.addCol(this, b_choose, s, 1, 0);
				chooseComponents.put(prefComponent, b_choose);
				prefComponent.addAdditionalComp(b_choose);
			}
		}
		s.gridx = 5;
		KUtil.addCol(this, new JLabel(""), s, 1, 1);
		s.weighty = 1;
		KUtil.newRow(this, new JLabel(""), s, 1);
		for (PrefComponent bean : chooseComponents.keySet()) {
			JButton btn = chooseComponents.get(bean);
			
			if(bean.getPropConfig().equals("revmaster.ac5_SingleWorkingHours")) {
				
				//ʱӼ㰴ť
				btn.addActionListener(new ActionListener() {
					@Override
					public void actionPerformed(ActionEvent e) {
						try {
							System.out.println("ѡĶ"+targetLine.getItemRevision().getType()
									+"Ϊ"+targetLine.getItemRevision().getStringProperty("object_name"));
						} catch (TCException e1) {
							//  Auto-generated catch block
							e1.printStackTrace();
						}
						
						new selectionCommand(targetLine,Field1,Field2,Field3,Field4,Field5);
						
					}
				});
			}else {
				btn.addActionListener(new ActionListener() {
					@Override
					public void actionPerformed(ActionEvent e) {
						bean.performChoose(null, itemType, AIFUtility.getCurrentApplication(), prefComponents);
					}
				});
			}
		}
		// add Hide Listener
		for (String[] hideProp : hideListenerMap.keySet()) {
			String condPropName = hideProp[0];
			String condPropValue = hideProp[1];
			String[] hidePropNames = hideListenerMap.get(hideProp);
			for (PrefComponent prefComponent : prefComponents) {
				if(!condPropName.equals(prefComponent.getPropConfig())) {
					continue;
				}
				System.out.println(">> Add Hide Listener: "+condPropName);
				JComponent valueComp = prefComponent.getValueComp();
				if(valueComp instanceof iComboBox) {
					((iComboBox)valueComp).addActionListener(new ActionListener() {
						@Override
						public void actionPerformed(ActionEvent arg0) {
							String item = prefComponent.getValue();
							System.out.println("[Check Hide] Select: "+item);
							if(item==null) {
								item = "";
							}
							boolean visible = !condPropValue.equals(item);
							System.out.println("Set Visible: "+visible+" -> "+Arrays.toString(hidePropNames));
							for (PrefComponent prefComponent : prefComponents) {
								if(KUtil.inArray(prefComponent.getPropConfig(), hidePropNames)>=0) {
									System.out.println(">> "+prefComponent.getPropConfig());
									prefComponent.setVisible(visible);
								}
							}
							revalidate();
							repaint();
						}
					});
				}
			}
		}
		//Load Property
		loadData();
		return true;
	}
	
	public boolean isModified() {
		for (PrefComponent prefComponent : prefComponents) {
			if(prefComponent.isModified()) {
				System.out.println("PROP Change: "+prefComponent.getPropConfig()+" -> "+prefComponent.getValue());
				return true;
			}
		}
		return false;
	}
	
	public void loadData() throws Exception{
		System.out.println("Load Data...");
		TCComponentItemRevision rev = this.targetLine.getItemRevision();
		TCComponentItem item = this.targetLine.getItem();
		TCComponent revForm = rev.getRelatedComponent("IMAN_master_form_rev");
		if (revForm == null) {
			throw new Exception(String.format(ProcessLocale.getString("nomasterform.ERROR1"), rev.toString()));
		}
		TCComponent itemForm = item.getRelatedComponent("IMAN_master_form");
		if (itemForm == null) {
			throw new Exception(String.format(ProcessLocale.getString("nomasterform.ERROR1"), item.toString()));
		}
		for (PrefComponent prefComponent : prefComponents) {
			String propConfig = prefComponent.getPropConfig();
			String propFrom = null, propName = null;
			String[] split =propConfig.split("\\.");
			if(KUtil.getLen(split)==2) {
				propFrom = split[0].trim().toUpperCase();
				propName = split[1].trim();
			}
			if (KUtil.isEmpty(propFrom) || KUtil.isEmpty(propName)) {
				continue;
			}
			if ("ITEM".equals(propFrom)) {
				prefComponent.setValueAndSave(item.getStringProperty(propName));
			} else if ("REV".equals(propFrom)) {
				prefComponent.setValueAndSave(rev.getStringProperty(propName));
			} else if ("ITEMMASTER".equals(propFrom)) {
				prefComponent.setValueAndSave(itemForm.getStringProperty(propName));
			} else if ("REVMASTER".equals(propFrom)) {
				prefComponent.setValueAndSave(revForm.getStringProperty(propName));
			} else {
				throw new Exception(String.format(KLocale.getString("proplocationnotdefined.ERROR1"), propFrom));
			}
		}
		System.out.println("Load Data Complete");
	}

	public void save() throws Exception{
		System.out.println("Save..."+this.targetLine);
		if (this.targetLine==null||!checkRequire()) {
			return;
		}
		//Save 
		Map<String, String> revPropMap = new HashMap<>();
		Map<String, String> revMasterPropMap = new HashMap<>();
		Map<String, String> itemPropMap = new HashMap<>();
		Map<String, String> itemMasterPropMap = new HashMap<>();
		for (PrefComponent prefComponent : this.prefComponents) {
			KUtil.initPropMap(prefComponent.getPropConfig(),prefComponent.getValue(),itemPropMap,itemMasterPropMap,revPropMap,revMasterPropMap);
		}
		TCComponentItemRevision rev = this.targetLine.getItemRevision();
		TCComponentItem item = this.targetLine.getItem();
		if(itemPropMap.size()>0) {
			item.setProperties(itemPropMap);
		}
		if(itemMasterPropMap.size()>0) {
			TCComponent itemForm = item.getRelatedComponent("IMAN_master_form");
			if (itemForm != null) {
				itemForm.setProperties(itemPropMap);
			}
		}
		if(revPropMap.size()>0) {
			rev.setProperties(revPropMap);
		}
		if(revMasterPropMap.size()>0) {
			TCComponent revForm = rev.getRelatedComponent("IMAN_master_form_rev");
			if (revForm != null) {
				revForm.setProperties(revMasterPropMap);
			}
		}
		this.targetLine.refresh();
		loadData();
		System.out.println("Save Success");
	}
	
	private boolean checkRequire() {
		List<String> requireTitles = new ArrayList<String>();
		for (PrefComponent prefComponent : this.prefComponents) {
			if (!prefComponent.checkRequire()) {
				requireTitles.add(prefComponent.getTitle().replace(" ", "").replace(":", "").replace(KUtil.getReg("CN_SYMBEL4"), "").replace(KUtil.getReg("CN_SYMBEL5"), ""));
			}
		}
		if (requireTitles.size() > 0) {
			KUtil.info(null, String.format(ProcessLocale.getString("requireprop.INFO1"), requireTitles.toString()));
			return false;
		}
		return true;
	}
	
	private TCComponentBOMWindow getWindow(TCSession session) throws Exception{
		TCComponentBOMWindow window = null;
		TCComponentBOMWindowType bomWinType = (TCComponentBOMWindowType) session.getTypeComponent("BOMWindow");
		window = bomWinType.create(null);
		return window;
	}
	
	private TCComponent[] query(TCSession session, String queryName, String[] aKey, String[] aVal) throws Exception {
		TCComponentQueryType imanQueryType = (TCComponentQueryType) session.getTypeComponent("ImanQuery");
		TCComponentQuery imancomponentquery = (TCComponentQuery) imanQueryType.find(queryName);
		if (imancomponentquery == null) {
			throw new Exception("δҵѯ " + queryName + "!");
		}
		aKey = session.getTextService().getTextValues(aKey);
//		for (int i = 0; i < aKey.length; i++) {
//			System.out.println(aKey[i] + "===============" + aVal[i]);
//		}
		TCComponentContextList componentContextList = imancomponentquery.getExecuteResultsList(aKey, aVal);
		return componentContextList.toTCComponentArray();
	}
}
