package cn.net.connor.process.revisemeprocess;

import com.teamcenter.rac.aif.AbstractAIFApplication;
import com.teamcenter.rac.aif.kernel.InterfaceAIFComponent;
import com.teamcenter.rac.kernel.TCComponentBOMLine;
import com.teamcenter.rac.kernel.TCComponentItem;
import com.teamcenter.rac.kernel.TCComponentItemRevision;
import com.teamcenter.rac.kernel.TCComponentItemType;
import com.teamcenter.rac.kernel.TCException;
import com.teamcenter.rac.util.Registry;

import cn.net.connor.process.ProcessUtil;
import k.KOperation2;
import k.util.KUtil;

public class ReviseMEProcessOperation extends KOperation2 {
	private static Registry REG = Registry.getRegistry(ReviseMEProcessOperation.class);
	protected TCComponentItemRevision procRev;

	public ReviseMEProcessOperation(AbstractAIFApplication app, String opName) {
		super(app, opName);
	}

	@Override
	public boolean init() throws Exception {
		InterfaceAIFComponent target = app.getTargetComponent();
		System.out.println("Select " + target);
		TCComponentItemRevision rev = null;
		if (target != null) {
			if (target instanceof TCComponentItemRevision) {
				rev = (TCComponentItemRevision) target;
			} else if (target instanceof TCComponentBOMLine) {
				rev = ((TCComponentBOMLine) target).getItemRevision();
			}
		}
		if (rev != null && ProcessUtil.isMEProcess(rev.getItem().getType())) {
			this.procRev = rev;
		}
		if (this.procRev == null) {
			throw new TCException(REG.getString("selectproc.ERROR"));
		}
		return true;
	}

	@Override
	public void execute() throws Exception {
		this.procRev.refresh();
		TCComponentItemRevision metarget = (TCComponentItemRevision) this.procRev.getRelatedComponent("IMAN_METarget");
		System.out.println("METarget: " + metarget);
		if (metarget != null) {
			TCComponentItem meItem = metarget.getItem();
			TCComponentItemRevision latestReleasedTarget = KUtil.getLastReleaseRevison(meItem);
			if (latestReleasedTarget == null) {
				throw new TCException(String.format(REG.getString("noreleasedtarget.ERROR1"), meItem.toString()));
			}
			if (!latestReleasedTarget.equals(metarget)) {
				this.procRev.remove("IMAN_METarget", metarget);
				this.procRev.refresh();
				this.procRev.add("IMAN_METarget", latestReleasedTarget);
				this.procRev.refresh();
			}
		}
		TCComponentItemType itemType = procRev.getItem().getTypeComponent();
		String newRevId = itemType.getNewRev(procRev.getItem());
		System.out.println("Revise to: " + newRevId);
		TCComponentItemRevision newRev;
		newRev = this.procRev.saveAs(newRevId);
		System.out.println("New Revision: " + newRev);
		KUtil.info(null, REG.getString("revise.SUCCESS"));
	}

	@Override
	public void clearCache() throws Exception {

	}

}
