package cn.net.connor.process.tsgcexport;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import com.teamcenter.rac.aif.kernel.AIFComponentContext;
import com.teamcenter.rac.aif.kernel.InterfaceAIFComponent;
import com.teamcenter.rac.kernel.TCComponentBOMLine;
import com.teamcenter.rac.kernel.TCComponentItemRevision;
import com.teamcenter.rac.kernel.TCSession;

import k.util.KUtil;

public class METargetBean {
	private TCComponentItemRevision meTargetRev;
	private List<TCComponentItemRevision> procRevs;

	public METargetBean(TCComponentItemRevision meTargetRev, List<TCComponentItemRevision> procRevs) {
		this.meTargetRev = meTargetRev;
		this.procRevs = procRevs;
	}

	public static METargetBean parse(TCComponentBOMLine bomline) throws Exception {
		if (bomline == null) {
			return null;
		}
		TCComponentItemRevision rev = bomline.getItemRevision();
		if (rev == null) {
			return null;
		}
		List<TCComponentItemRevision> procRevs = new ArrayList<TCComponentItemRevision>();
		rev.refresh();
		AIFComponentContext[] proc = rev.whereReferencedByTypeRelation(null, new String[] { "IMAN_METarget" });
		System.out.println("proc: " + rev + " -> " + Arrays.toString(proc));
		int len = KUtil.getLen(proc);
		for (int i = 0; i < len; i++) {
			InterfaceAIFComponent comp = proc[i].getComponent();
			if (comp instanceof TCComponentItemRevision) {
				if (!procRevs.contains(comp)) {
					procRevs.add((TCComponentItemRevision) comp);
				}
			}
		}
		if (procRevs.size() == 0) {
			return null;
		}
		return new METargetBean(rev, procRevs);
	}

	public void readTSGC(TCSession session, List<TSGCBean> tsgcBeans) throws Exception {
		int procCnt = procRevs.size();
		for (int i = 0; i < procCnt; i++) {
			TCComponentItemRevision procRev = procRevs.get(i);
			System.out.println("search tsgc: " + procRev);
			TSGCBean.parse(session, procRev, meTargetRev, tsgcBeans);
		}
	}
}
