package cn.net.connor.process.tsgcrefexport;

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.FlowLayout;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

import com.teamcenter.rac.util.MessageBox;
import com.teamcenter.rac.util.Registry;

import k.KDialog;
import k.KDialogController;
import k.util.KUtil;

@SuppressWarnings("serial")
public class TSGCRefExportDialog extends KDialog {

	private static final Registry REG = Registry.getRegistry(TSGCRefExportDialog.class);
	private TSGCRefExportDialogController controller;
	private JButton b_export;
	private JButton b_cancel;
	protected JTextField tf_id;
	protected JTextField tf_name;

	public TSGCRefExportDialog(KDialogController controller) {
		super(controller);
		this.controller = (TSGCRefExportDialogController) controller;
	}

	@Override
	protected void addListeners() {
		this.b_cancel.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				disposeDialog();
			}
		});
		this.b_export.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				try {
					controller.doExport();
				} catch (Exception e1) {
					e1.printStackTrace();
					MessageBox.post(TSGCRefExportDialog.this, e1);
				}
			}
		});
	}

	@Override
	protected void initUI() {
		this.setTitle(REG.getString("dialog.TITLE"));
		this.setLayout(new BorderLayout());
		this.add(BorderLayout.CENTER, initCenterPanel());
		this.add(BorderLayout.SOUTH, initBtnPanel());
	}

	private Component initBtnPanel() {
		JPanel panel = new JPanel(new FlowLayout(FlowLayout.CENTER, 25, 5));
		panel.add(this.b_export = new JButton(REG.getString("export.BTN")));
		panel.add(this.b_cancel = new JButton(REG.getString("cancel.BTN")));
		this.b_cancel.setPreferredSize(this.b_export.getPreferredSize());
		return panel;
	}

	private Component initCenterPanel() {
		JPanel panel = new JPanel(new GridBagLayout());
		panel.setBorder(BorderFactory.createEmptyBorder(30, 20, 30, 20));
		GridBagConstraints s = getGridBagConstraints(0, 0, new Insets(8, 5, 8, 5));
		KUtil.newRow(panel, new JLabel(REG.getString("id.LABEL")), s, 1);
		KUtil.addCol(panel, this.tf_id = new JTextField(18), s, 1, 0);
		KUtil.newRow(panel, new JLabel(REG.getString("name.LABEL")), s, 1);
		KUtil.addCol(panel, this.tf_name = new JTextField(18), s, 1, 0);
		return panel;
	}

}
