package cn.net.connor.process.workflowname;

import java.awt.Toolkit;
import java.awt.datatransfer.Clipboard;
import java.awt.datatransfer.StringSelection;
import java.util.LinkedHashMap;
import java.util.Map;

import com.teamcenter.rac.aif.AbstractAIFApplication;
import com.teamcenter.rac.aif.kernel.InterfaceAIFComponent;
import com.teamcenter.rac.kernel.TCComponent;
import com.teamcenter.rac.kernel.TCException;

import cn.net.connor.process.ProcessLocale;
import k.KOperation2;
import k.util.KUtil;

public class WorkflowNameOperation extends KOperation2 {

	public static final String PREF_WORKFLOWNAME = "Connor_CopyWorkflowName";
	protected Map<String, String> typeConfigMap = new LinkedHashMap<String, String>();
	protected TCComponent target;

	public WorkflowNameOperation(AbstractAIFApplication app, String opName) {
		super(app, opName);
	}

	@Override
	public boolean init() throws Exception {
		String[] prefValues = KUtil.getPrefVals(session, PREF_WORKFLOWNAME);
		int len = KUtil.getLen(prefValues);
		System.out.println("Preference " + PREF_WORKFLOWNAME + " -> " + len);
		for (int i = 0; i < len; i++) {
			String prefValue = prefValues[i];
			int ind = prefValue.indexOf('=');
			String type = null;
			String config = null;
			if (ind > 0) {
				type = prefValue.substring(0, ind).trim();
				config = prefValue.substring(ind + 1);
			}
			if (KUtil.isEmpty(type) || KUtil.isEmpty(config)) {
				System.out.println(">> Error config: " + prefValue);
				continue;
			}
			typeConfigMap.put(type, config);
		}
		if (typeConfigMap.size() == 0) {
			throw new TCException(String.format(ProcessLocale.getString("pref.ERROR1"), PREF_WORKFLOWNAME));
		}
		InterfaceAIFComponent target = app.getTargetComponent();
		String targetType = target == null ? "" : target.getType();
		System.out.println("Select: " + target + " -> " + targetType);
		if(!typeConfigMap.containsKey(targetType)) {
			throw new TCException(String.format(ProcessLocale.getString("copytarget.ERROR1"), KUtil.getTypeNames(session, this.typeConfigMap.keySet().toArray())));
		}
		this.target = (TCComponent) target;
		return true;
	}

	@Override
	public void execute() throws Exception {
		session.setStatus(ProcessLocale.getString("readdata.STATUS"));
		String value = KUtil.getPropValueByPath(target, this.typeConfigMap.get(target.getType()), ";");
		System.out.println("Copy Name: ["+value+"]");
		StringSelection selection = new StringSelection(value);
		Clipboard clipboard = Toolkit.getDefaultToolkit().getSystemClipboard();
		clipboard.setContents(selection, selection);
	}

	@Override
	public void clearCache() throws Exception {
		typeConfigMap.clear();
	}

}
